(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
(function (process){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// resolves . and .. elements in a path array with directory names there
// must be no slashes, empty elements, or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  // if the path tries to go above the root, `up` ends up > 0
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
    var last = parts[i];
    if (last === '.') {
      parts.splice(i, 1);
    } else if (last === '..') {
      parts.splice(i, 1);
      up++;
    } else if (up) {
      parts.splice(i, 1);
      up--;
    }
  }

  // if the path is allowed to go above the root, restore leading ..s
  if (allowAboveRoot) {
    for (; up--; up) {
      parts.unshift('..');
    }
  }

  return parts;
}

// Split a filename into [root, dir, basename, ext], unix version
// 'root' is just a slash, or nothing.
var splitPathRe =
    /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
var splitPath = function(filename) {
  return splitPathRe.exec(filename).slice(1);
};

// path.resolve([from ...], to)
// posix version
exports.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (typeof path !== 'string') {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path.charAt(0) === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
    return !!p;
  }), !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
exports.normalize = function(path) {
  var isAbsolute = exports.isAbsolute(path),
      trailingSlash = substr(path, -1) === '/';

  // Normalize the path
  path = normalizeArray(filter(path.split('/'), function(p) {
    return !!p;
  }), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
exports.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
exports.join = function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return exports.normalize(filter(paths, function(p, index) {
    if (typeof p !== 'string') {
      throw new TypeError('Arguments to path.join must be strings');
    }
    return p;
  }).join('/'));
};


// path.relative(from, to)
// posix version
exports.relative = function(from, to) {
  from = exports.resolve(from).substr(1);
  to = exports.resolve(to).substr(1);

  function trim(arr) {
    var start = 0;
    for (; start < arr.length; start++) {
      if (arr[start] !== '') break;
    }

    var end = arr.length - 1;
    for (; end >= 0; end--) {
      if (arr[end] !== '') break;
    }

    if (start > end) return [];
    return arr.slice(start, end - start + 1);
  }

  var fromParts = trim(from.split('/'));
  var toParts = trim(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};

exports.sep = '/';
exports.delimiter = ':';

exports.dirname = function(path) {
  var result = splitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


exports.basename = function(path, ext) {
  var f = splitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


exports.extname = function(path) {
  return splitPath(path)[3];
};

function filter (xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];
    for (var i = 0; i < xs.length; i++) {
        if (f(xs[i], i, xs)) res.push(xs[i]);
    }
    return res;
}

// String.prototype.substr - negative index don't work in IE8
var substr = 'ab'.substr(-1) === 'b'
    ? function (str, start, len) { return str.substr(start, len) }
    : function (str, start, len) {
        if (start < 0) start = str.length + start;
        return str.substr(start, len);
    }
;

}).call(this,require('_process'))
},{"_process":2}],2:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],3:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./lib/agent-factory", "./lib/feature-detection"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var agent_factory_1 = require("./lib/agent-factory");
    var feature_detection_1 = require("./lib/feature-detection");
    var featureDetection = null;
    try {
        featureDetection = new feature_detection_1.FeatureDetection(window);
        if (window && window["$Sealights"]) {
            var agent = agent_factory_1.AgentFactory.createBrowserAgent(window, featureDetection, window["$Sealights"]);
            if (agent) {
                agent.start();
                window["$SealightsAgent"] = agent;
            }
            else if (featureDetection.hasConsoleLogAPI()) {
                console.log("Sealights browser listener is disabled");
            }
            else {
                alert("Sealights browser listener is disabled");
            }
        }
    }
    catch (e) {
        if (featureDetection && featureDetection.hasConsoleLogAPI()) {
            console.log("Sealights browser listener failed to start. Error: ", e);
        }
    }
});

},{"./lib/agent-factory":4,"./lib/feature-detection":20}],4:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./state-tracker", "./test-state-helper", "./entities/environment-data", "./services/http/http-client", "./services/json/json-client", "./istanbul-to-footprints-convertor", "./istanbul-to-footprints-convertor-v3", "./services/footprints-service-proxy", "./footprints-queue-sender", "./watchdog", "./code-coverage-manager", "./browser-agent", "./queues/footprints-items-queue", "./configuration-manager", "./logger/log-factory", "./basic-uuid-generator", "./window-timers-wrapper", "./color-cookie-handler"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var state_tracker_1 = require("./state-tracker");
    var test_state_helper_1 = require("./test-state-helper");
    var environment_data_1 = require("./entities/environment-data");
    var http_client_1 = require("./services/http/http-client");
    var json_client_1 = require("./services/json/json-client");
    var istanbul_to_footprints_convertor_1 = require("./istanbul-to-footprints-convertor");
    var istanbul_to_footprints_convertor_v3_1 = require("./istanbul-to-footprints-convertor-v3");
    var footprints_service_proxy_1 = require("./services/footprints-service-proxy");
    var footprints_queue_sender_1 = require("./footprints-queue-sender");
    var watchdog_1 = require("./watchdog");
    var code_coverage_manager_1 = require("./code-coverage-manager");
    var browser_agent_1 = require("./browser-agent");
    var footprints_items_queue_1 = require("./queues/footprints-items-queue");
    var configuration_manager_1 = require("./configuration-manager");
    var log_factory_1 = require("./logger/log-factory");
    var basic_uuid_generator_1 = require("./basic-uuid-generator");
    var window_timers_wrapper_1 = require("./window-timers-wrapper");
    var color_cookie_handler_1 = require("./color-cookie-handler");
    var FOOTPRINTS_SENDER_WATCHDOG = "FootPrintsSenderWatchdog";
    var ACTIVE_EXECUTION_WATCHDOG = "ActiveExecutionWatchdog";
    var AgentFactory = (function () {
        function AgentFactory() {
        }
        AgentFactory.createBrowserAgent = function (window, featureDetection, basicConfiguration) {
            var configurationManager = AgentFactory.createConfigurationManager(basicConfiguration, window);
            var configuration = configurationManager.getConfiguration();
            var stateTracker = AgentFactory.createStateTracker(configuration, window, featureDetection);
            var colorCookieHandler = AgentFactory.createColorCookieHandler(window);
            if (!configurationManager.isValidConfiguration()) {
                return null;
            }
            var footprintsQueueSender = AgentFactory.createFootprintsQueueSender(window, featureDetection, configuration, stateTracker);
            var logger = AgentFactory.createLogger("BrowserAgent", configuration);
            var agent = new browser_agent_1.BrowserAgent(logger, footprintsQueueSender, configuration, window, colorCookieHandler, stateTracker);
            return agent;
        };
        AgentFactory.createFootprintsQueueSender = function (window, featureDetection, configuration, stateTracker) {
            var watchdog = AgentFactory.createWatchdog(window, configuration, FOOTPRINTS_SENDER_WATCHDOG);
            var footprintsServiceProxy = AgentFactory.createFootprintsServiceProxy(window, featureDetection, configuration);
            var codeCoverageManager = AgentFactory.createCodeCoverageManager(window, configuration);
            var testStateHelper = AgentFactory.createTestStateHelper();
            var environmentData = AgentFactory.createEnvironmentData(window, configuration);
            var footprintsItemsQueue = AgentFactory.createFootprintsItemsQueue(configuration);
            var logger = AgentFactory.createLogger("FootprintsQueueSender", configuration);
            var footprintsQueueSender = new footprints_queue_sender_1.FootprintsQueueSender(watchdog, footprintsServiceProxy, codeCoverageManager, stateTracker, testStateHelper, environmentData, configuration, footprintsItemsQueue, logger);
            return footprintsQueueSender;
        };
        AgentFactory.createWatchdog = function (window, configuration, classname) {
            var interval = (configuration.interval || 10) * 1000;
            var logger = AgentFactory.createLogger(classname, configuration);
            var windowTimeoutWrapper = AgentFactory.createWindowTimersWrapper(window);
            var watchdog = new watchdog_1.Watchdog(interval, windowTimeoutWrapper, { autoReset: true }, logger);
            return watchdog;
        };
        AgentFactory.createCodeCoverageManager = function (window, configuration) {
            var istanbulToFootprintsConvertor = AgentFactory.createInstanbulToFootprintsConvertor(window, configuration);
            var codeCoverageManager = new code_coverage_manager_1.CodeCoverageManager(istanbulToFootprintsConvertor, configuration);
            return codeCoverageManager;
        };
        AgentFactory.createFootprintsServiceProxy = function (window, featureDetection, configuration) {
            var jsonClient = AgentFactory.createJsonClient(window, featureDetection, configuration);
            var logger = AgentFactory.createLogger("FootprintsServiceProxy", configuration);
            var footprintsServiceProxy = new footprints_service_proxy_1.FootprintsServiceProxy(configuration, jsonClient, logger);
            return footprintsServiceProxy;
        };
        AgentFactory.createJsonClient = function (window, featureDetection, configuration) {
            var httpClient = AgentFactory.createHttpClient(window, featureDetection, configuration);
            var jsonClient = new json_client_1.JsonClient(httpClient, configuration.token);
            return jsonClient;
        };
        AgentFactory.createHttpClient = function (window, featureDetection, configuration) {
            var logger = AgentFactory.createLogger("HttpClient", configuration);
            var httpClient = new http_client_1.HttpClient(window, featureDetection, logger);
            return httpClient;
        };
        AgentFactory.createStateTracker = function (configuration, window, featureDetection) {
            var watchdog = AgentFactory.createWatchdog(window, configuration, ACTIVE_EXECUTION_WATCHDOG);
            var logger = AgentFactory.createLogger("StateTracker", configuration);
            var jsonClient = AgentFactory.createJsonClient(window, featureDetection, configuration);
            var stateTracker = new state_tracker_1.StateTracker(configuration, jsonClient, watchdog, logger);
            return stateTracker;
        };
        AgentFactory.createColorCookieHandler = function (window) {
            var colorCookieHandler = new color_cookie_handler_1.ColorCookieHandler(window);
            return colorCookieHandler;
        };
        AgentFactory.createTestStateHelper = function () {
            var testStateHelper = new test_state_helper_1.TestStateHelper();
            return testStateHelper;
        };
        AgentFactory.createWindowTimersWrapper = function (window) {
            var windowTimersWrapper = new window_timers_wrapper_1.WindowTimersWrapper(window);
            return windowTimersWrapper;
        };
        AgentFactory.createEnvironmentData = function (window, configuration) {
            if (!environment_data_1.EnvironmentData.constantAgentId)
                environment_data_1.EnvironmentData.constantAgentId = basic_uuid_generator_1.BasicUuidGenerator.createUuid() + "<|>" + this.getTime(window);
            var environmentData = environment_data_1.EnvironmentData.create(configuration);
            return environmentData;
        };
        AgentFactory.createInstanbulToFootprintsConvertor = function (window, configuration) {
            var instanbulToFootprintsConvertor = null;
            if (configuration.resolveWithoutHash) {
                instanbulToFootprintsConvertor = new istanbul_to_footprints_convertor_v3_1.IstanbulToFootprintsConvertorV3(window, configuration);
            }
            else {
                instanbulToFootprintsConvertor = new istanbul_to_footprints_convertor_1.IstanbulToFootprintsConverter(window, configuration);
            }
            return instanbulToFootprintsConvertor;
        };
        AgentFactory.createFootprintsItemsQueue = function (configuration) {
            var footprintsItemsQueue = new footprints_items_queue_1.FootprintsItemsQueue(configuration);
            return footprintsItemsQueue;
        };
        AgentFactory.createConfigurationManager = function (basicConfiguration, window) {
            var logger = AgentFactory.createLogger("ConfigurationManager", basicConfiguration);
            var configurationManager = new configuration_manager_1.ConfigurationManager(logger, basicConfiguration, window);
            return configurationManager;
        };
        AgentFactory.createLogger = function (className, basicConfiguration) {
            return log_factory_1.LogFactory.createLogger(className, basicConfiguration.logLevel);
        };
        AgentFactory.getTime = function (window) {
            if (window && window.performance && typeof window.performance.now === "function") {
                return performance.now();
            }
            return new Date().getTime();
        };
        return AgentFactory;
    }());
    exports.AgentFactory = AgentFactory;
});

},{"./basic-uuid-generator":5,"./browser-agent":6,"./code-coverage-manager":7,"./color-cookie-handler":8,"./configuration-manager":10,"./entities/environment-data":18,"./footprints-queue-sender":21,"./istanbul-to-footprints-convertor":23,"./istanbul-to-footprints-convertor-v3":22,"./logger/log-factory":25,"./queues/footprints-items-queue":27,"./services/footprints-service-proxy":28,"./services/http/http-client":29,"./services/json/json-client":32,"./state-tracker":34,"./test-state-helper":35,"./watchdog":38,"./window-timers-wrapper":39}],5:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var BasicUuidGenerator = (function () {
        function BasicUuidGenerator() {
        }
        BasicUuidGenerator.createUuid = function () {
            var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            });
            return uuid;
        };
        return BasicUuidGenerator;
    }());
    exports.BasicUuidGenerator = BasicUuidGenerator;
});

},{}],6:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./config"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var config_1 = require("./config");
    var BrowserAgent = (function () {
        function BrowserAgent(logger, footprintsQueueSender, configuration, window, colorCookieHandler, stateTracker) {
            var _this = this;
            this.logger = logger;
            this.footprintsQueueSender = footprintsQueueSender;
            this.configuration = configuration;
            this.window = window;
            this.colorCookieHandler = colorCookieHandler;
            this.stateTracker = stateTracker;
            this._isStarted = false;
            if (logger == null)
                throw new Error("'logger' cannot be null or undefined");
            if (footprintsQueueSender == null)
                throw new Error("'footprintsQueueSender' cannot be null or undefined");
            if (configuration == null)
                throw new Error("'configuration' cannot be null or undefined");
            if (window == null)
                throw new Error("'window' cannot be null or undefined");
            logger.info("Sealights " + config_1.SL_AGENT_TYPE + " version " + config_1.SL_AGENT_VERSION + " has been loaded");
            this.stateTracker.addOnColorChangedListener(function () {
                var color = _this.stateTracker.getCurrentColor();
                _this.colorCookieHandler.handleColorChange(color);
            });
        }
        BrowserAgent.prototype.start = function () {
            if (this._isStarted)
                return;
            this.logger.info("Agent is starting. registerShutdownHook:" + this.configuration.registerShutdownHook);
            if (this.configuration.registerShutdownHook) {
                this.registerShutdownHook();
            }
            this.footprintsQueueSender.start();
            this._isStarted = true;
        };
        BrowserAgent.prototype.stop = function () {
            if (!this._isStarted)
                return;
            this.logger.info("Agent is stopping.");
            this.footprintsQueueSender.sendAllSync();
            this._isStarted = false;
        };
        BrowserAgent.prototype.setCurrentTestIdentifier = function (testIdentifier) {
            this.logger.info("Agent is setting current test identifier. testIdentifier:'" + testIdentifier + "'.");
            this.stateTracker.setCurrentTestIdentifier(testIdentifier);
        };
        BrowserAgent.prototype.endTest = function () {
            this.logger.info("Test '" + this.stateTracker.getCurrentTestIdentifier() + "' ended, sending remaining footprints");
            this.footprintsQueueSender.sendAll();
            this.stateTracker.setCurrentTestIdentifier(null);
        };
        BrowserAgent.prototype.isStarted = function () {
            return this._isStarted;
        };
        BrowserAgent.prototype.registerShutdownHook = function () {
            var context = this;
            var oldUnload = this.window.onunload;
            this.window.onunload = function () {
                if (oldUnload) {
                    oldUnload.call(arguments);
                }
                context.stop();
            };
            var oldBeforeUnload = this.window.onbeforeunload;
            this.window.onbeforeunload = function () {
                if (oldBeforeUnload) {
                    oldBeforeUnload.call(arguments);
                }
                context.stop();
            };
        };
        return BrowserAgent;
    }());
    exports.BrowserAgent = BrowserAgent;
});

},{"./config":9}],7:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var CodeCoverageManager = (function () {
        function CodeCoverageManager(convertor, configuration) {
            this.convertor = convertor;
            this.configuration = configuration;
            this.aggregatedCoverage = {};
            this.isDestroyed = false;
        }
        CodeCoverageManager.prototype.findCoverageContainer = function () {
            if (window["$SealightsCoverage"]) {
                return window["$SealightsCoverage"];
            }
            var re = /__coverage__/;
            var windowObjectNames = Object.keys(window);
            var coverageContainer = null;
            for (var i = 0; i < windowObjectNames.length; i++) {
                var windowObjectName = windowObjectNames[i];
                if (re.exec(windowObjectName) !== null) {
                    coverageContainer = window[windowObjectName];
                    return coverageContainer;
                }
            }
            return null;
        };
        CodeCoverageManager.prototype.getFootprints = function (testInfo) {
            var counters = this.getCounters(true);
            return this.convertor.convert(counters, testInfo.testName, testInfo.executionId);
        };
        CodeCoverageManager.prototype._clearCounters = function (istanbulCoverageObject) {
            if (!istanbulCoverageObject)
                return;
            if (this.isDestroyed)
                return;
            var context = this;
            this.forEachProp(istanbulCoverageObject, function (moduleName, m) {
                context.aggregatedCoverage[moduleName] = context.aggregatedCoverage[moduleName] || { s: {}, b: {}, f: {} };
                var am = context.aggregatedCoverage[moduleName];
                context.forEachProp(m.s, function (sid, s) {
                    am.s[sid] = (am.s[sid] || 0) + m.s[sid];
                    m.s[sid] = 0;
                });
                context.forEachProp(m.b, function (bid, b) {
                    am.b[bid] = am.b[bid] || Array.apply(null, Array(m.b[bid].length)).map(Number.prototype.valueOf, 0);
                    for (var idx = 0; idx < am.b[bid].length; idx++) {
                        am.b[bid][idx] += m.b[bid][idx];
                        m.b[bid][idx] = 0;
                    }
                });
                context.forEachProp(m.f, function (fid, f) {
                    am.f[fid] = (am.f[fid] || 0) + m.f[fid];
                    m.f[fid] = 0;
                });
            });
        };
        CodeCoverageManager.prototype.cloneCodeMetrics = function (o) {
            var cloned = {};
            for (var i in o) {
                cloned[i] = this.cloneModule(o[i]);
            }
            return cloned;
        };
        CodeCoverageManager.prototype.cloneModule = function (m) {
            var cm = { b: {}, f: {}, s: {} };
            for (var i in m.s) {
                cm.s[i] = m.s[i];
            }
            for (var i in m.f) {
                cm.f[i] = m.f[i];
            }
            for (var i in m.b) {
                cm.b[i] = m.b[i].slice();
            }
            cm.metadata = m.metadata;
            cm.path = m.path;
            cm.fnMap = m.fnMap;
            cm.fnToBranch = m.fnToBranch;
            cm.branchMap = m.branchMap;
            cm.inputSourceMap = m.inputSourceMap;
            return cm;
        };
        CodeCoverageManager.prototype.forEachProp = function (obj, func) {
            Object.keys(obj).forEach(function (k) {
                func(k, obj[k]);
            });
        };
        CodeCoverageManager.prototype.clearCounters = function () {
            if (this.isDestroyed)
                return;
            var ct = this.findCoverageContainer();
            if (ct) {
                this._clearCounters(ct);
            }
        };
        CodeCoverageManager.prototype.getCounters = function (clearAfterwards) {
            if (this.isDestroyed)
                return {};
            var ct = this.findCoverageContainer();
            if (ct) {
                var ret = this.cloneCodeMetrics(ct);
                if (clearAfterwards)
                    this._clearCounters(ct);
                return ret;
            }
        };
        ;
        return CodeCoverageManager;
    }());
    exports.CodeCoverageManager = CodeCoverageManager;
});

},{}],8:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./state-tracker"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var state_tracker_1 = require("./state-tracker");
    var ColorCookieHandler = (function () {
        function ColorCookieHandler(window) {
            this.window = window;
            this.COOKIE_KEY = "x-sl-testid";
        }
        ColorCookieHandler.prototype.setCookie = function (color) {
            var cookie = this.COOKIE_KEY + "=" + color;
            this.window.document.cookie = cookie;
        };
        ColorCookieHandler.prototype.handleColorChange = function (color) {
            if (color != null && color != state_tracker_1.StateTracker.ANONYMOUS_FOOTPRINTS_COLOR) {
                this.setCookie(color);
            }
            else {
                this.removeCookie();
            }
        };
        ColorCookieHandler.prototype.removeCookie = function () {
            this.window.document.cookie = this.COOKIE_KEY + '=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';
        };
        ColorCookieHandler.prototype.getCookie = function () {
            return this.window.document.cookie;
        };
        return ColorCookieHandler;
    }());
    exports.ColorCookieHandler = ColorCookieHandler;
});

},{"./state-tracker":34}],9:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SL_AGENT_VERSION = "1.0.0";
    exports.SL_AGENT_TYPE = "browser";
});

},{}],10:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./entities/configuration-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var configuration_data_1 = require("./entities/configuration-data");
    var ConfigurationManager = (function () {
        function ConfigurationManager(logger, basicConfiguration, window) {
            this.logger = logger;
            this.basicConfiguration = basicConfiguration;
            this.window = window;
            if (logger == null)
                throw new Error("'logger' cannot be null or undefined");
            if (basicConfiguration == null)
                throw new Error("'basicConfiguration' cannot be null or undefined");
            if (window == null)
                throw new Error("'window' cannot be null or undefined");
        }
        ConfigurationManager.prototype.getConfiguration = function () {
            if (this.currentConfiguration)
                return this.currentConfiguration;
            var configurationData = this.getDefaults();
            configurationData.labId = this.resolveLabId();
            this.overrideConfiguration(configurationData);
            this.currentConfiguration = configurationData;
            this.printConfiguration(configurationData);
            this.validateConfiguration(configurationData);
            return configurationData;
        };
        ConfigurationManager.prototype.getDefaults = function () {
            var config = new configuration_data_1.ConfigurationData();
            config.appName = this.basicConfiguration.appName;
            config.branchName = this.basicConfiguration.branchName;
            config.buildName = this.basicConfiguration.buildName;
            config.buildSessionId = this.basicConfiguration.buildSessionId;
            config.customerId = this.basicConfiguration.customerId;
            config.token = this.basicConfiguration.token;
            config.server = this.basicConfiguration.server;
            config.interval = this.basicConfiguration.interval || 10;
            config.maxItemsInQueue = this.basicConfiguration.maxItemsInQueue || 500;
            config.workspacepath = this.basicConfiguration.workspacepath;
            return config;
        };
        ConfigurationManager.prototype.resolveLabId = function () {
            var labId = this.basicConfiguration.labId;
            if (labId) {
                this.logger.info("Using labId from basic configuration. LabId:" + labId);
                return labId;
            }
            labId = this.readLabIdFromWindow();
            if (labId) {
                this.logger.info("Using labId from the 'window' object. LabId:" + labId);
                return labId;
            }
            labId = this.readLabIdFromSessionStorage();
            if (labId) {
                this.logger.info("Using labId from session storage. LabId:" + labId);
                return labId;
            }
            labId = this.basicConfiguration.buildSessionId;
            if (labId) {
                this.logger.info("Using buildSessionId as labId. LabId:" + labId);
                return labId;
            }
            labId = this.basicConfiguration.appName;
            if (labId) {
                this.logger.info("Using appName as labId. LabId:" + labId);
                return labId;
            }
            return "DefaultLabId";
        };
        ConfigurationManager.prototype.overrideConfiguration = function (configurationData) {
            for (var p in this.basicConfiguration) {
                configurationData[p] = this.basicConfiguration[p];
            }
            this.logger.info("[TO CS] - TODO: Send request to server to get the configuration.");
        };
        ConfigurationManager.prototype.printConfiguration = function (configurationData) {
            this.logger.info("***********************************************************");
            this.logger.info("Current configuration:");
            this.logger.info("------------------------------------------------");
            for (var prop in configurationData) {
                this.logger.info(prop + ": '" + configurationData[prop]) + "'";
            }
            this.logger.info("***********************************************************");
        };
        ConfigurationManager.prototype.validateConfiguration = function (configurationData) {
            var _this = this;
            var fieldsWithError = [];
            if (!configurationData.customerId || configurationData.customerId == "")
                fieldsWithError.push("customerId");
            if (!configurationData.server || configurationData.server == "")
                fieldsWithError.push("server");
            if (!configurationData.appName || configurationData.appName == "")
                fieldsWithError.push("appName");
            if (!configurationData.branchName || configurationData.branchName == "")
                fieldsWithError.push("branchName");
            if (!configurationData.buildName || configurationData.buildName == "")
                fieldsWithError.push("buildName");
            if (!configurationData.token || configurationData.token == "")
                fieldsWithError.push("token");
            if (fieldsWithError.length > 0) {
                this.logger.warn("------------------------------------------------");
                this.logger.warn("Detected an invalid configuration:");
                fieldsWithError.forEach(function (field) {
                    _this.logger.warn("'" + field + "' is required but it had a 'null' or empty value.");
                });
                this.logger.warn("Please fix the configuration prior to using SeaLights.");
                this.logger.warn("------------------------------------------------");
            }
            this._isValidConfiguration = fieldsWithError.length == 0;
        };
        ConfigurationManager.prototype.isValidConfiguration = function () {
            return this._isValidConfiguration;
        };
        ConfigurationManager.prototype.readLabIdFromSessionStorage = function () {
            var labId = null;
            if (this.window.sessionStorage && typeof (this.window.sessionStorage) === "function") {
                labId = this.window.sessionStorage.getItem(ConfigurationManager.LAB_ID_KEY);
            }
            return labId;
        };
        ConfigurationManager.prototype.readLabIdFromWindow = function () {
            return this.window[ConfigurationManager.LAB_ID_KEY];
        };
        ConfigurationManager.LAB_ID_KEY = "__sl.labId__";
        return ConfigurationManager;
    }());
    exports.ConfigurationManager = ConfigurationManager;
});

},{"./entities/configuration-data":17}],11:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ElementType;
    (function (ElementType) {
        ElementType["METHOD"] = "method";
        ElementType["BRANCH"] = "branch";
    })(ElementType = exports.ElementType || (exports.ElementType = {}));
});

},{}],12:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../validation-utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var validation_utils_1 = require("../validation-utils");
    var FileElement = (function () {
        function FileElement(type, startPosition, endPosition, uniqueIdKey, filename) {
            validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(type, "type");
            validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(startPosition, "startPosition");
            validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(endPosition, "endPosition");
            validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(uniqueIdKey, "uniqueIdKey");
            validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(filename, "filename");
            this._type = type;
            this._startPosition = startPosition;
            this._endPosition = endPosition;
            this._uniqueIdKey = uniqueIdKey;
            this._filename = filename;
        }
        Object.defineProperty(FileElement.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (value) {
                this._type = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "startPosition", {
            get: function () {
                return this._startPosition;
            },
            set: function (value) {
                this._startPosition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "endPosition", {
            get: function () {
                return this._endPosition;
            },
            set: function (value) {
                this._endPosition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "uniqueIdKey", {
            get: function () {
                return this._uniqueIdKey;
            },
            set: function (value) {
                this._uniqueIdKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "uniqueIdKey_decl", {
            get: function () {
                return this._uniqueIdKey_decl;
            },
            set: function (value) {
                this._uniqueIdKey_decl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "filename", {
            get: function () {
                return this._filename;
            },
            set: function (value) {
                this._filename = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileElement.prototype, "uniqueId", {
            get: function () {
                return this._uniqueId;
            },
            set: function (value) {
                this._uniqueId = value;
            },
            enumerable: true,
            configurable: true
        });
        FileElement.prototype.isStartsAfter = function (fileElement) {
            if (parseInt(this._startPosition.line.toString()) < parseInt(fileElement.startPosition.line.toString())) {
                return false;
            }
            if (parseInt(this._startPosition.line.toString()) > parseInt(fileElement.startPosition.line.toString())) {
                return true;
            }
            if (parseInt(this._startPosition.column.toString()) > parseInt(fileElement.startPosition.column.toString())) {
                return true;
            }
            return false;
        };
        FileElement.prototype.isStartsBefore = function (fileElement) {
            if (parseInt(this._startPosition.line.toString()) > parseInt(fileElement.startPosition.line.toString())) {
                return false;
            }
            if (parseInt(this._startPosition.line.toString()) < parseInt(fileElement.startPosition.line.toString())) {
                return true;
            }
            if (parseInt(this._startPosition.column.toString()) < parseInt(fileElement.startPosition.column.toString())) {
                return true;
            }
            return false;
        };
        FileElement.prototype.isEndsAfter = function (fileElement) {
            if (parseInt(this._endPosition.line.toString()) < parseInt(fileElement.endPosition.line.toString())) {
                return false;
            }
            if (parseInt(this._endPosition.line.toString()) > parseInt(fileElement.endPosition.line.toString())) {
                return true;
            }
            if (parseInt(this._endPosition.column.toString()) > parseInt(fileElement.endPosition.column.toString())) {
                return true;
            }
            return false;
        };
        FileElement.prototype.isEndsBefore = function (fileElement) {
            if (parseInt(this._endPosition.line.toString()) > parseInt(fileElement.endPosition.line.toString())) {
                return false;
            }
            if (parseInt(this._endPosition.line.toString()) < parseInt(fileElement.endPosition.line.toString())) {
                return true;
            }
            if (parseInt(this._endPosition.column.toString()) < parseInt(fileElement.endPosition.column.toString())) {
                return true;
            }
            return false;
        };
        return FileElement;
    }());
    exports.FileElement = FileElement;
});

},{"../validation-utils":37}],13:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../logger/log-factory", "../utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var log_factory_1 = require("../logger/log-factory");
    var utils_1 = require("../utils");
    var OriginalModuleLoader = (function () {
        function OriginalModuleLoader(coverageObject, window, workspacePath) {
            if (!coverageObject) {
                throw new Error('coverageObject' + OriginalModuleLoader.NULL_OR_UNDEFINED_MESSAGE);
            }
            if (!window) {
                throw new Error('window' + OriginalModuleLoader.NULL_OR_UNDEFINED_MESSAGE);
            }
            if (!workspacePath) {
                throw new Error('workspacePath' + OriginalModuleLoader.NULL_OR_UNDEFINED_MESSAGE);
            }
            this.window = window;
            this.coverageObject = coverageObject;
            this.workspacePath = workspacePath;
            this.logger = log_factory_1.LogFactory.createLogger("OriginalModuleLoader", "");
            this._fileToSourceMapConsumer = {};
        }
        OriginalModuleLoader.prototype.load = function () {
            var _this = this;
            var modules = Object.keys(this.coverageObject);
            modules.map(function (moduleName) { return _this.tryLoadOriginalModule(moduleName); });
        };
        OriginalModuleLoader.prototype.tryLoadOriginalModule = function (moduleName) {
            var sourceMapsReader = this.getOrCreateSourceMapConsumer(moduleName);
            if (!sourceMapsReader) {
                return;
            }
            this.readOriginalModule(moduleName, sourceMapsReader);
        };
        OriginalModuleLoader.prototype.readOriginalModule = function (moduleName, sourceMapsReader) {
            var _this = this;
            var module = this.coverageObject[moduleName];
            module.branchMap = module.branchMap || {};
            module.fnMap = module.fnMap || {};
            Object.keys(module.branchMap).forEach(function (key) { return _this.resolveAndAddBranch(module.branchMap[key], sourceMapsReader, moduleName); });
            Object.keys(module.fnMap).map(function (key) { return _this.resolveAndAddMethod(module.fnMap[key], sourceMapsReader, moduleName); });
        };
        OriginalModuleLoader.prototype.resolveAndAddMethod = function (method, sourceMapsReader, moduleName) {
            var originalMethod = this.createEmptyMethodObject();
            originalMethod.name = method.name;
            var originalModuleName = this.loadOriginalDataForElement(sourceMapsReader, method, moduleName, originalMethod);
            if (originalModuleName) {
                this.addMethodToModule(originalModuleName, originalMethod);
            }
        };
        OriginalModuleLoader.prototype.resolveAndAddBranch = function (branch, sourceMapsReader, moduleName) {
            var _this = this;
            var originalBranch = this.createEmptyBranchObject();
            originalBranch.type = branch.type;
            var originalModuleName = this.loadOriginalDataForElement(sourceMapsReader, branch, moduleName, originalBranch);
            if (originalModuleName) {
                var originalLocations = branch.locations.map(function (locationElement) { return _this.createElementSourceData(locationElement, sourceMapsReader, moduleName); });
                originalBranch.locations = originalLocations;
                this.addBranchToModule(originalModuleName, originalBranch);
            }
        };
        OriginalModuleLoader.prototype.loadOriginalDataForElement = function (sourceMapsReader, element, moduleName, originalElement) {
            var sourceMapDataForStart = this.readSourceMapData(sourceMapsReader, element.loc.start, moduleName);
            var sourceMapDataForEnd = this.readSourceMapData(sourceMapsReader, element.loc.end, moduleName);
            if (!sourceMapDataForStart)
                return;
            originalElement.loc.start = sourceMapDataForStart.originalPosition;
            originalElement.line = sourceMapDataForStart.originalPosition.line;
            var originalModuleName = sourceMapDataForStart.originalFilename;
            if (sourceMapDataForEnd) {
                originalElement.loc.end = sourceMapDataForEnd.originalPosition;
            }
            if (element.decl) {
                originalElement.decl = {};
                var sourceMapDataForDeclStart = this.readSourceMapData(sourceMapsReader, element.decl.start, moduleName);
                var sourceMapDataForDeclEnd = this.readSourceMapData(sourceMapsReader, element.decl.end, moduleName);
                if (sourceMapDataForDeclStart) {
                    originalElement.decl.start = sourceMapDataForDeclStart.originalPosition;
                }
                if (sourceMapDataForDeclEnd) {
                    originalElement.decl.end = sourceMapDataForDeclEnd.originalPosition;
                }
            }
            return originalModuleName;
        };
        OriginalModuleLoader.prototype.addBranchToModule = function (moduleName, branch) {
            var module = this.getOrCreateIstanbulModule(moduleName);
            var key = this.createElementKey(branch);
            if (!module.branchMap[key]) {
                module.branchMap[key] = branch;
            }
        };
        OriginalModuleLoader.prototype.addMethodToModule = function (moduleName, method) {
            var module = this.getOrCreateIstanbulModule(moduleName);
            var key = this.createElementKey(method);
            if (!module.fnMap[key]) {
                module.fnMap[key] = method;
            }
        };
        OriginalModuleLoader.prototype.createElementSourceData = function (locationElement, sourceMapsReader, moduleName) {
            var sourceMapDataForStart = this.readSourceMapData(sourceMapsReader, locationElement.start, moduleName);
            var sourceMapDataForEnd = this.readSourceMapData(sourceMapsReader, locationElement.end, moduleName);
            if (!sourceMapDataForStart && !sourceMapDataForEnd) {
                return {};
            }
            var sourceLocationElement = {
                start: sourceMapDataForStart.originalPosition,
                end: sourceMapDataForEnd.originalPosition,
            };
            return sourceLocationElement;
        };
        OriginalModuleLoader.prototype.getOrCreateIstanbulModule = function (moduleName) {
            var module = this.coverageObject[moduleName];
            if (!module) {
                module = this.createIstanbulModule(moduleName);
                this.coverageObject[moduleName] = module;
            }
            return module;
        };
        OriginalModuleLoader.prototype.getOrCreateSourceMapConsumer = function (moduleName) {
            var sourceMapLibrary = (this.window)["sourceMap"];
            if ((!this.fileToSourceMapConsumer[moduleName]) && (this.coverageObject[moduleName] && this.coverageObject[moduleName].inputSourceMap && sourceMapLibrary)) {
                var sourceMap = this.coverageObject[moduleName].inputSourceMap;
                if (sourceMap == null)
                    return null;
                if (!sourceMap.version && sourceMap.inputSourceMap != null) {
                    sourceMap = sourceMap.inputSourceMap;
                }
                if (!sourceMap.version)
                    return null;
                var sourceMapConsumer_1 = new sourceMapLibrary.SourceMapConsumer(sourceMap);
                this.fileToSourceMapConsumer[moduleName] = sourceMapConsumer_1;
            }
            var sourceMapConsumer = this.fileToSourceMapConsumer[moduleName];
            return sourceMapConsumer;
        };
        OriginalModuleLoader.prototype.readSourceMapData = function (sourceMaps, start, fullPath) {
            if (!sourceMaps)
                return null;
            try {
                var originalPosition = sourceMaps.originalPositionFor(start);
                if (originalPosition && originalPosition.source && originalPosition.line !== null && originalPosition.column !== null) {
                    var originalFilename = originalPosition.source;
                    if (originalFilename.indexOf("webpack:///webpack/") === -1 &&
                        originalFilename.indexOf("webpack:///external") === -1) {
                        if (originalFilename.indexOf('webpack:///') === 0) {
                            originalFilename = originalFilename.substring(11);
                        }
                        originalFilename = utils_1.Utils.resolveOriginalFullFileName(fullPath, originalFilename);
                        var originalPositionObj = { line: originalPosition.line, column: originalPosition.column };
                        var result = { originalFilename: originalFilename, originalPosition: originalPositionObj };
                        return result;
                    }
                }
            }
            catch (e) {
                console.log(e);
            }
            return null;
        };
        OriginalModuleLoader.prototype.createElementKey = function (element) {
            return element.loc.start.line + ":" + element.loc.start.column;
        };
        OriginalModuleLoader.prototype.createEmptyBranchObject = function () {
            return {
                loc: {},
                decl: {},
                locations: [],
                type: "",
                line: 0
            };
        };
        OriginalModuleLoader.prototype.createEmptyMethodObject = function () {
            return {
                loc: {},
                decl: {},
                name: "",
                line: 0
            };
        };
        OriginalModuleLoader.prototype.createIstanbulModule = function (path) {
            return {
                s: {},
                f: {},
                b: {},
                fnMap: {},
                statementMap: {},
                branchMap: {},
                path: path,
                uniqueIdsMap: null
            };
        };
        Object.defineProperty(OriginalModuleLoader.prototype, "fileToSourceMapConsumer", {
            get: function () {
                return this._fileToSourceMapConsumer;
            },
            set: function (value) {
                this._fileToSourceMapConsumer = value;
            },
            enumerable: true,
            configurable: true
        });
        OriginalModuleLoader.NULL_OR_UNDEFINED_MESSAGE = " cannot be null or undefined";
        return OriginalModuleLoader;
    }());
    exports.OriginalModuleLoader = OriginalModuleLoader;
});

},{"../logger/log-factory":25,"../utils":36}],14:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./contracts", "../logger/log-factory", "./file-element"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var contracts_1 = require("./contracts");
    var log_factory_1 = require("../logger/log-factory");
    var file_element_1 = require("./file-element");
    var METHOD_DELIMITER = "@";
    var BRANCH_DELIMITER = "|";
    var NULL_PARAM_MESSAGE = "cannot be null or undefined";
    var UniqueIdConverter = (function () {
        function UniqueIdConverter(filename) {
            if (!filename) {
                throw new Error("'filename' " + NULL_PARAM_MESSAGE);
            }
            this.filename = filename;
            this.logger = log_factory_1.LogFactory.createLogger("UniqueIdConverter", "");
            this._uniqueIdsMap = {};
        }
        UniqueIdConverter.prototype.createFileElement = function (element, filename, type) {
            var startPosition = this.createElementPosition(element.position);
            var endPosition = this.createElementPosition(element.endPosition);
            return new file_element_1.FileElement(type, startPosition, endPosition, element.uniqueId, filename);
        };
        UniqueIdConverter.prototype.sortElements = function () {
            return this._fileElements.sort(this.comparePosition);
        };
        UniqueIdConverter.prototype.createElementsArray = function (file) {
            var methodsArray = [];
            var branchesArray = [];
            file.methods = file.methods || [];
            file.branches = file.branches || [];
            this.fillFileElementsArray(file.methods, methodsArray, contracts_1.ElementType.METHOD);
            this.fillFileElementsArray(file.branches, methodsArray, contracts_1.ElementType.BRANCH);
            return methodsArray.concat(branchesArray);
        };
        UniqueIdConverter.prototype.createNewUniqueIds = function () {
            for (var i = 0; i < this._fileElements.length; i++) {
                var currentElement = this._fileElements[i];
                if (currentElement.type == contracts_1.ElementType.METHOD) {
                    currentElement.uniqueId = currentElement.filename + METHOD_DELIMITER + i;
                }
                if (currentElement.type == contracts_1.ElementType.BRANCH) {
                    currentElement.uniqueId = currentElement.filename + BRANCH_DELIMITER + i;
                }
                this.logger.debug("[UniqueIdConverter] uniqueId " + currentElement.uniqueIdKey + "\n                                converted to " + currentElement.uniqueId);
                this._uniqueIdsMap[currentElement.uniqueIdKey] = currentElement.uniqueId;
                if (currentElement.uniqueIdKey_decl) {
                    this._uniqueIdsMap[currentElement.uniqueIdKey_decl] = currentElement.uniqueId;
                }
            }
        };
        UniqueIdConverter.prototype.setAndInitFile = function (file) {
            this._fileElements = this.createElementsArray(file);
        };
        UniqueIdConverter.prototype.process = function () {
            this.filterDuplicatesElements();
            this._fileElements = this.sortElements();
            this.removeBranchesOutOfMethods();
            this.logger.debug("sorted " + this._fileElements.length + " elements");
            this.createNewUniqueIds();
        };
        UniqueIdConverter.prototype.createElementPosition = function (position) {
            var line;
            var column;
            if (Array.isArray(position) && position.length == 2) {
                line = parseInt(position[0]);
                column = parseInt(position[1]);
            }
            else {
                throw new Error("element has no correct position array, cannot resolve position");
            }
            return {
                line: line,
                column: column
            };
        };
        UniqueIdConverter.prototype.fillFileElementsArray = function (elements, methodsArray, type) {
            for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
                var element = elements_1[_i];
                methodsArray.push(this.createFileElement(element, this.filename, type));
            }
        };
        UniqueIdConverter.prototype.comparePosition = function (elm1, elm2) {
            if (elm1.startPosition.line < elm2.startPosition.line) {
                return -1;
            }
            if (elm1.startPosition.line > elm2.startPosition.line) {
                return 1;
            }
            if (elm1.startPosition.column < elm2.startPosition.column) {
                return -1;
            }
            if (elm1.startPosition.column > elm2.startPosition.column) {
                return 1;
            }
            return 0;
        };
        Object.defineProperty(UniqueIdConverter.prototype, "uniqueIdsMap", {
            get: function () {
                return this._uniqueIdsMap;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UniqueIdConverter.prototype, "fileElements", {
            get: function () {
                return this._fileElements;
            },
            set: function (value) {
                this._fileElements = value;
            },
            enumerable: true,
            configurable: true
        });
        UniqueIdConverter.prototype.filterDuplicatesElements = function () {
            var existedKeys = {};
            this._fileElements = this._fileElements.filter(function (element) {
                if (existedKeys[element.uniqueIdKey] ||
                    (element.uniqueIdKey_decl && existedKeys[element.uniqueIdKey_decl])) {
                    return false;
                }
                existedKeys[element.uniqueIdKey] = true;
                if (element.uniqueIdKey_decl) {
                    existedKeys[element.uniqueIdKey_decl] = true;
                }
                return true;
            });
        };
        UniqueIdConverter.prototype.removeBranchesOutOfMethods = function () {
            var allBranches = this._fileElements.filter(function (element) { return element.type === contracts_1.ElementType.BRANCH; });
            var validBranches = [];
            var allMethods = this._fileElements.filter(function (element) { return element.type === contracts_1.ElementType.METHOD; });
            var methodsIndex = 0;
            for (var _i = 0, allBranches_1 = allBranches; _i < allBranches_1.length; _i++) {
                var branch = allBranches_1[_i];
                for (var i = methodsIndex; i < allMethods.length; i++) {
                    var currentMethod = allMethods[i];
                    var branchPosition = this.checkBranchPosition(branch, currentMethod);
                    if (branchPosition === 0) {
                        validBranches.push(branch);
                        break;
                    }
                    if (branchPosition === 1) {
                        methodsIndex++;
                    }
                }
            }
            this._fileElements = validBranches.concat(allMethods);
            this._fileElements = this.sortElements();
        };
        UniqueIdConverter.prototype.checkBranchPosition = function (branch, method) {
            if (branch.isStartsAfter(method) && branch.isEndsBefore(method)) {
                return 0;
            }
            if (branch.isStartsBefore(method) && branch.isEndsBefore(method)) {
                return -1;
            }
            if (branch.isStartsAfter(method) && branch.isEndsAfter(method)) {
                return 1;
            }
            this.logger.warn("branch started in " + branch.startPosition + " located across methods, probably some error");
            return 0;
        };
        return UniqueIdConverter;
    }());
    exports.UniqueIdConverter = UniqueIdConverter;
});

},{"../logger/log-factory":25,"./contracts":11,"./file-element":12}],15:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Delegate = (function () {
        function Delegate() {
            this.functions = new Array();
        }
        Delegate.prototype.addListener = function (func) {
            if (!func)
                return;
            if (this.functions)
                this.functions.push(func);
        };
        Delegate.prototype.fire = function () {
            if (!this.functions)
                return;
            for (var i = 0; i < this.functions.length; i++) {
                this.functions[i]();
            }
        };
        return Delegate;
    }());
    exports.Delegate = Delegate;
});

},{}],16:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var BasicConfigurationData = (function () {
        function BasicConfigurationData() {
            this.logLevel = "info";
        }
        return BasicConfigurationData;
    }());
    exports.BasicConfigurationData = BasicConfigurationData;
});

},{}],17:[function(require,module,exports){
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./basic-configuation-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var basic_configuation_data_1 = require("./basic-configuation-data");
    var ConfigurationData = (function (_super) {
        __extends(ConfigurationData, _super);
        function ConfigurationData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.registerShutdownHook = true;
            _this.enabled = true;
            return _this;
        }
        return ConfigurationData;
    }(basic_configuation_data_1.BasicConfigurationData));
    exports.ConfigurationData = ConfigurationData;
});

},{"./basic-configuation-data":16}],18:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../config"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var config_1 = require("../config");
    var EnvironmentData = (function () {
        function EnvironmentData() {
        }
        EnvironmentData.create = function (configuration) {
            var data = new EnvironmentData();
            data.agentType = config_1.SL_AGENT_TYPE;
            data.agentVersion = config_1.SL_AGENT_VERSION;
            data.agentId = EnvironmentData.constantAgentId;
            data.labId = configuration.labId || "";
            data.meta = {
                navigator: window.navigator,
                userAgent: window.navigator && window.navigator.userAgent,
                location: window.location
            };
            return data;
        };
        return EnvironmentData;
    }());
    exports.EnvironmentData = EnvironmentData;
});

},{"../config":9}],19:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FootprintsItemData = (function () {
        function FootprintsItemData() {
        }
        return FootprintsItemData;
    }());
    exports.FootprintsItemData = FootprintsItemData;
});

},{}],20:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FeatureDetection = (function () {
        function FeatureDetection(window) {
            this.window = window;
            if (!window)
                throw new Error("'window' cannot be null or undefined");
        }
        FeatureDetection.prototype.hasBeaconAPI = function () {
            var result = window.navigator && this.isFunction(window.navigator["sendBeacon"]);
            return result;
        };
        FeatureDetection.prototype.hasConsoleLogAPI = function () {
            var result = window.console && this.isFunction(window.console.log);
            return result;
        };
        FeatureDetection.prototype.hasJsonAPI = function () {
            var result = ((JSON) && this.isFunction(JSON.stringify) && this.isFunction(JSON.parse));
            return result;
        };
        FeatureDetection.prototype.isFunction = function (o) {
            return ((o) && (typeof o === "function"));
        };
        return FeatureDetection;
    }());
    exports.FeatureDetection = FeatureDetection;
});

},{}],21:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./entities/footprints-item-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var footprints_item_data_1 = require("./entities/footprints-item-data");
    var FootprintsQueueSender = (function () {
        function FootprintsQueueSender(watchdog, footprintsServiceProxy, codeCoverageManager, stateTracker, testStateHelper, environmentData, configuration, footprintsQueue, logger) {
            var _this = this;
            this.watchdog = watchdog;
            this.footprintsServiceProxy = footprintsServiceProxy;
            this.codeCoverageManager = codeCoverageManager;
            this.stateTracker = stateTracker;
            this.testStateHelper = testStateHelper;
            this.environmentData = environmentData;
            this.configuration = configuration;
            this.footprintsQueue = footprintsQueue;
            this.logger = logger;
            this.isStarted = false;
            if (watchdog == null)
                throw new Error("'watchdog' cannot be null or undefined");
            if (footprintsServiceProxy == null)
                throw new Error("'footprintsServiceProxy' cannot be null or undefined");
            if (codeCoverageManager == null)
                throw new Error("'codeCoverageManager' cannot be null or undefined");
            if (stateTracker == null)
                throw new Error("'stateTracker' cannot be null or undefined");
            if (testStateHelper == null)
                throw new Error("'testStateHelper' cannot be null or undefined");
            if (environmentData == null)
                throw new Error("'environmentData' cannot be null or undefined");
            if (configuration == null)
                throw new Error("'configuration' cannot be null or undefined");
            if (footprintsQueue == null)
                throw new Error("'footprintsQueue' cannot be null or undefined");
            if (logger == null)
                throw new Error("'logger' cannot be null or undefined");
            this.context = this;
            this.watchdog.addOnAlarmListener(function () {
                _this.context.onTimerTick();
            });
        }
        FootprintsQueueSender.prototype.onTimerTick = function () {
            if (!this.stateTracker.shouldCollectFootprints()) {
                return;
            }
            var footprints = this.getCurrentFootprints();
            this.send(footprints);
        };
        FootprintsQueueSender.prototype.start = function () {
            if (this.isStarted)
                return;
            this.watchdog.start();
            this.isStarted = true;
        };
        FootprintsQueueSender.prototype.stop = function () {
            if (!this.isStarted)
                return;
            this.watchdog.stop();
            this.isStarted = false;
        };
        FootprintsQueueSender.prototype.send = function (footprintsData, async, shouldRequeue) {
            if (async === void 0) { async = true; }
            if (shouldRequeue === void 0) { shouldRequeue = true; }
            if (!footprintsData) {
                this.logger.info("No need to send footprints as the 'footprintsData' is null or undefined.");
                return;
            }
            var request = this.createRequest(footprintsData);
            if (request == null) {
                this.logger.info("No need to send footprints as the request is empty.");
                return;
            }
            var context = this;
            var onSuccess = function () {
                context.logger.info("Sent footprints successfully");
            };
            var onError = function (response) {
                context.logger.error("Failed while trying to send footprints. response.responseText: '" + response.responseText + "'. response.statusCode:" + response.statusCode);
                if (shouldRequeue) {
                    context.logger.info("Requeuing footprints again");
                    context.footprintsQueue.requeueItems(footprintsData);
                }
            };
            this.footprintsServiceProxy.submitRequest(request, onSuccess, onError, async);
        };
        FootprintsQueueSender.prototype.sendAllSync = function () {
            if (!this.stateTracker.shouldCollectFootprints()) {
                return;
            }
            this.logger.info("Sending all remaining footprints synchronously.");
            this.delayIfHasRequestsInProgress();
            var async = false;
            var footprints = this.getCurrentFootprints();
            this.send(footprints, async);
        };
        FootprintsQueueSender.prototype.sendAll = function () {
            var footprints = this.getCurrentFootprints();
            this.send(footprints);
        };
        FootprintsQueueSender.prototype.delayIfHasRequestsInProgress = function () {
            var counter = this.configuration.delayShutdownInSeconds || 30;
            while (this.footprintsServiceProxy.hasRequestsInProgress() && counter-- > 0) {
                this.logger.info("Has other requests in progress. Sleeping.. # of requests: " + this.footprintsServiceProxy.getRequestsInProgressCount() + ". Remaining retries: " + counter);
                this.sleep(1000);
            }
        };
        FootprintsQueueSender.prototype.pushCurrentFootprints = function () {
            if (!this.stateTracker.shouldCollectFootprints()) {
                return;
            }
            var testId = this.stateTracker.getCurrentTestIdentifier();
            var testInfo = this.testStateHelper.splitTestIdToExecutionAndTestName(testId);
            var footprints = this.codeCoverageManager.getFootprints(testInfo);
            if (this.configuration.resolveWithoutHash) {
                this.enqueueV5Footprints(footprints);
            }
            else {
                this.enqueueV2Footprints(footprints, testInfo);
            }
        };
        FootprintsQueueSender.prototype.enqueueV2Footprints = function (appsAndFootprintsArray, testInfo) {
            if (appsAndFootprintsArray && appsAndFootprintsArray.length) {
                var queueItem = new footprints_item_data_1.FootprintsItemData();
                queueItem.testName = testInfo.testName;
                queueItem.executionId = testInfo.executionId;
                queueItem.apps = appsAndFootprintsArray;
                this.footprintsQueue.enqueueItem(queueItem);
            }
        };
        FootprintsQueueSender.prototype.enqueueV5Footprints = function (footprintsRequest) {
            if (!footprintsRequest)
                return;
            if (!footprintsRequest.apps || footprintsRequest.apps.length == 0)
                return;
            if (!footprintsRequest.tests || footprintsRequest.tests.length == 0)
                return;
            this.footprintsQueue.enqueueItem(footprintsRequest);
        };
        FootprintsQueueSender.prototype.getCurrentFootprints = function () {
            this.pushCurrentFootprints();
            var footprints = this.footprintsQueue.getQueueContentsAndEmptyQueue();
            return footprints;
        };
        FootprintsQueueSender.prototype.createRequest = function (data) {
            if (this.configuration.resolveWithoutHash) {
                return this.createV5FootprintsRequest(data);
            }
            return this.createV2FootprintsRequest(data);
        };
        FootprintsQueueSender.prototype.createV5FootprintsRequest = function (footprintsData) {
            var originalRequest = footprintsData[0];
            if (!originalRequest) {
                return null;
            }
            if ((!this.hasApps(originalRequest)) || (!this.hasTests(originalRequest))) {
                return null;
            }
            var request = {};
            request.customerId = this.configuration.customerId;
            request.environment = this.environmentData;
            request.configurationData = this.configuration;
            request.apps = originalRequest.apps;
            request.tests = originalRequest.tests;
            request.meta = originalRequest.meta;
            return request;
        };
        FootprintsQueueSender.prototype.createV2FootprintsRequest = function (appsAndFootprintsArray) {
            if (!appsAndFootprintsArray || !appsAndFootprintsArray.length) {
                return null;
            }
            var request = {};
            request.customerId = this.configuration.customerId;
            request.items = appsAndFootprintsArray;
            request.environment = this.environmentData;
            request.configurationData = this.configuration;
            return request;
        };
        FootprintsQueueSender.prototype.sleep = function (millis) {
            var date = new Date();
            var curDate = null;
            do {
                curDate = new Date();
            } while (curDate.getTime() - date.getTime() < millis);
        };
        FootprintsQueueSender.prototype.hasApps = function (request) {
            return request.apps && request.apps.length > 0;
        };
        FootprintsQueueSender.prototype.hasTests = function (request) {
            return request.tests && request.tests.length > 0;
        };
        return FootprintsQueueSender;
    }());
    exports.FootprintsQueueSender = FootprintsQueueSender;
});

},{"./entities/footprints-item-data":19}],22:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils", "./coverage-elements/unique-id-converter", "./coverage-elements/contracts", "./logger/log-factory", "path", "./coverage-elements/original-module-loader", "./short-name-to-file-mapper", "./coverage-elements/file-element"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils_1 = require("./utils");
    var unique_id_converter_1 = require("./coverage-elements/unique-id-converter");
    var contracts_1 = require("./coverage-elements/contracts");
    var log_factory_1 = require("./logger/log-factory");
    var path = require("path");
    var original_module_loader_1 = require("./coverage-elements/original-module-loader");
    var short_name_to_file_mapper_1 = require("./short-name-to-file-mapper");
    var file_element_1 = require("./coverage-elements/file-element");
    var IstanbulToFootprintsConvertorV3 = (function () {
        function IstanbulToFootprintsConvertorV3(window, cfg) {
            this.window = window;
            this.cfg = cfg;
            this.totalTests = 0;
            if (!window)
                throw new Error("window is required");
            if (!cfg)
                throw new Error("cfg is required");
            this.logger = log_factory_1.LogFactory.createLogger("UniqueIdConverter", "");
        }
        IstanbulToFootprintsConvertorV3.prototype.resetState = function () {
            this.totalTests = 0;
            this.eidToHitsIndex = {};
            this.uniqueIdToElement = {};
            this.testNameToTestData = {};
            this.fileNameToAppFile = {};
            this.fileToSourceMapConsumer = {};
        };
        IstanbulToFootprintsConvertorV3.prototype.convert = function (istanbulFootprints, testName, executionId, mockTime) {
            this.resetState();
            var result = this.createFootprintsFile();
            var app = result.apps[0];
            var localTime = mockTime ? mockTime : new Date().getTime();
            var test = this.getOrCreateTestData(testName, executionId, localTime, result);
            this.loadOriginalModules(istanbulFootprints);
            this.mapShortNamesToFiles(istanbulFootprints);
            for (var moduleName in istanbulFootprints) {
                var istanbulModule = istanbulFootprints[moduleName];
                if (!istanbulModule) {
                    continue;
                }
                var scopeData = {
                    test: test,
                    app: app,
                    relativeModulePath: utils_1.Utils.getRelativeModulePath(istanbulModule.path, this.cfg.workspacepath),
                    modulePath: istanbulModule.path,
                    istanbulModule: istanbulModule,
                    sourceMapOrigin: {}
                };
                result.meta.moduleToSourceMap.push({
                    path: istanbulModule.path,
                    relativePath: scopeData.relativeModulePath,
                    sourceMapOrigin: scopeData.sourceMapOrigin
                });
                if (istanbulModule.f) {
                    this.addMethodsWithHits(scopeData, istanbulFootprints);
                }
                if (istanbulModule.b) {
                    this.addBranchesWithHits(scopeData, istanbulFootprints);
                }
            }
            result.apps = this.filterAppsWithoutHits(result.apps);
            return result;
        };
        IstanbulToFootprintsConvertorV3.prototype.filterAppsWithoutHits = function (apps) {
            var _this = this;
            if (!apps)
                return apps;
            return apps.filter(function (app) { return _this.filterFilesWithoutHits(app); });
        };
        IstanbulToFootprintsConvertorV3.prototype.filterFilesWithoutHits = function (app) {
            var _this = this;
            var hasFiles = false;
            if (!app || !app.files) {
                return hasFiles;
            }
            app.files = app.files.filter(function (file) { return _this.filterElementsWithoutHits(file); });
            hasFiles = app.files.length > 0;
            return hasFiles;
        };
        IstanbulToFootprintsConvertorV3.prototype.filterElementsWithoutHits = function (file) {
            var hasMethodHits = this.filterElementWithoutHits(file, "methods");
            var hasBranchHits = this.filterElementWithoutHits(file, "branches");
            var hasLineHits = this.filterElementWithoutHits(file, "lines");
            var hasHits = hasMethodHits || hasBranchHits || hasLineHits;
            return hasHits;
        };
        IstanbulToFootprintsConvertorV3.prototype.filterElementWithoutHits = function (file, coverageType) {
            var _this = this;
            var fileObject = file;
            var arrayOfCodeElements = (fileObject[coverageType] || []);
            arrayOfCodeElements = arrayOfCodeElements.filter(function (ce) { return _this.hasHit(ce); });
            fileObject[coverageType] = arrayOfCodeElements;
            var hasHits = (arrayOfCodeElements.length > 0);
            return hasHits;
        };
        IstanbulToFootprintsConvertorV3.prototype.hasHit = function (element) {
            var hasHitInAnyTest = element.hits.some(function (hitToTest) { return hitToTest[1] > 0; });
            return hasHitInAnyTest;
        };
        IstanbulToFootprintsConvertorV3.prototype.addMethodsWithHits = function (scopeData, istanbulFootprints) {
            var istanbulModule = scopeData.istanbulModule;
            for (var methodId in istanbulModule.f) {
                var hits = istanbulModule.f[methodId];
                if (hits > 0) {
                    var methodData = istanbulModule.fnMap[methodId];
                    this.addOrUpdateMethodElement(scopeData, methodData, hits, istanbulFootprints);
                }
            }
        };
        IstanbulToFootprintsConvertorV3.prototype.addBranchesWithHits = function (scopeData, istanbulFootprints) {
            var istanbulModule = scopeData.istanbulModule;
            for (var branchId in istanbulModule.b) {
                var probesArray = istanbulModule.b[branchId];
                for (var idx = 0; idx < probesArray.length; idx++) {
                    var hits = probesArray[idx];
                    if (hits > 0) {
                        var branchData = istanbulModule.branchMap[branchId];
                        this.addOrUpdateBranchElement(scopeData, branchData, idx, hits, istanbulFootprints);
                    }
                }
            }
        };
        IstanbulToFootprintsConvertorV3.prototype.addOrUpdateMethodElement = function (scopeData, methodData, hits, istanbulFootprints) {
            var _this = this;
            var relativeOriginalFileName = utils_1.Utils.getRelativeModulePath(methodData.originalFilename, this.cfg.workspacepath);
            var methodPosition = methodData.decl || methodData.loc;
            this.addOrUpdateElement(scopeData, methodPosition, relativeOriginalFileName, hits, function (position, scopeData) {
                var shortName = _this.shortNameToFileMapper.resolveShortNameForFile(position.fullFilePath);
                var uniqueIdKey = shortName + "@" + _this.formatLoc(position.start);
                var newUniqueId = _this.createNewUniqueId(uniqueIdKey, scopeData, istanbulFootprints, position.fullFilePath);
                return newUniqueId;
            }, this.getOrCreateMethodElement);
        };
        IstanbulToFootprintsConvertorV3.prototype.addOrUpdateBranchElement = function (scopeData, branchData, probeIndex, hits, istanbulFootprints) {
            var _this = this;
            var probePositionData = branchData.locations[probeIndex];
            var relativeOriginalFileName = utils_1.Utils.getRelativeModulePath(branchData.originalFilename, this.cfg.workspacepath);
            this.addOrUpdateElement(scopeData, probePositionData, relativeOriginalFileName, hits, function (position, scopeData) {
                var shortName = _this.shortNameToFileMapper.resolveShortNameForFile(position.fullFilePath);
                var uniqueIdKey = shortName + "|" + _this.formatLoc(position.start) + "|" + probeIndex;
                var newUniqueId = _this.createNewUniqueId(uniqueIdKey, scopeData, istanbulFootprints, position.fullFilePath);
                return newUniqueId;
            }, this.getOrCreateBranchElement);
        };
        IstanbulToFootprintsConvertorV3.prototype.addOrUpdateElement = function (scopeData, startPositionData, originalFilename, hits, createUniqueId, getOrCreateElement) {
            var sourceMapConsumer = this.getOrCreateSourceMapConsumer(scopeData.istanbulModule, scopeData.relativeModulePath);
            var file = this.getOrCreateFootprintsAppFile(scopeData.relativeModulePath, scopeData.app);
            var position = this.getPosition(sourceMapConsumer, startPositionData, scopeData.relativeModulePath, originalFilename, scopeData.modulePath);
            scopeData.sourceMapOrigin.window = scopeData.sourceMapOrigin.window || position.sourceMapOrigin.window;
            scopeData.sourceMapOrigin.instrumentation = scopeData.sourceMapOrigin.instrumentation || position.sourceMapOrigin.instrumentation;
            var uniqueId = createUniqueId(position, scopeData);
            if (!uniqueId) {
                return;
            }
            var element = getOrCreateElement.call(this, uniqueId, file);
            this.addOrUpdateElementHits(scopeData.test, uniqueId, element, hits);
        };
        IstanbulToFootprintsConvertorV3.prototype.getOrCreateSourceMapConsumer = function (istanbulModule, relativePath) {
            var sourceMapLibrary = (this.window)["sourceMap"];
            if ((!this.fileToSourceMapConsumer[relativePath]) && (istanbulModule.inputSourceMap && sourceMapLibrary)) {
                var sourceMap = istanbulModule.inputSourceMap;
                if (sourceMap == null)
                    return null;
                if (!sourceMap.version && sourceMap.inputSourceMap != null) {
                    sourceMap = sourceMap.inputSourceMap;
                }
                if (!sourceMap.version)
                    return null;
                var sourceMapConsumer_1 = new sourceMapLibrary.SourceMapConsumer(sourceMap);
                this.fileToSourceMapConsumer[relativePath] = sourceMapConsumer_1;
            }
            var sourceMapConsumer = this.fileToSourceMapConsumer[relativePath];
            return sourceMapConsumer;
        };
        IstanbulToFootprintsConvertorV3.prototype.getPosition = function (sourceMapConsumer, startPositionData, relativePath, originalFilename, modulePath) {
            var sourceMapData = this.readSourceMapData(sourceMapConsumer, startPositionData.start, relativePath);
            var filePath = relativePath;
            var start = startPositionData.start;
            var fullFilePath = modulePath;
            var sourceMapOrigin = { window: false, instrumentation: false };
            if (sourceMapData) {
                filePath = sourceMapData.originalFilename;
                start = sourceMapData.originalStart;
                sourceMapOrigin.window = true;
                fullFilePath = sourceMapData.originalFullFilename;
            }
            else {
                if (startPositionData.originalStart) {
                    start = startPositionData.originalStart;
                    sourceMapOrigin.instrumentation = true;
                }
                if (originalFilename) {
                    filePath = originalFilename;
                    sourceMapOrigin.instrumentation = true;
                }
            }
            return {
                start: start,
                filePath: filePath,
                fullFilePath: fullFilePath,
                sourceMapOrigin: sourceMapOrigin
            };
        };
        IstanbulToFootprintsConvertorV3.prototype.addOrUpdateElementHits = function (testData, elementUniqueId, element, hits) {
            var HITS_INDEX = 1;
            var eid = elementUniqueId + "|" + testData.index;
            var index = this.eidToHitsIndex[eid];
            if (index != null) {
                var testIndexAndHits = element.hits[index];
                var elementHits = testIndexAndHits[HITS_INDEX];
                elementHits = elementHits + hits;
                testIndexAndHits[HITS_INDEX] = elementHits;
            }
            else {
                var testIndexAndHits = new Array();
                testIndexAndHits.push(testData.index);
                testIndexAndHits.push(hits);
                var length_1 = element.hits.push(testIndexAndHits);
                this.eidToHitsIndex[eid] = length_1 - 1;
            }
        };
        IstanbulToFootprintsConvertorV3.prototype.getOrCreateTestData = function (testName, executionId, localTime, result) {
            if (!this.testNameToTestData[testName]) {
                var test_1 = {
                    executionId: executionId,
                    localTime: localTime,
                    testName: testName
                };
                result.tests.push(test_1);
                this.testNameToTestData[testName] = {
                    index: this.totalTests++,
                    test: test_1
                };
            }
            return this.testNameToTestData[testName];
        };
        IstanbulToFootprintsConvertorV3.prototype.getOrCreateMethodElement = function (uniqueId, file) {
            if (!this.uniqueIdToElement[uniqueId]) {
                var x = {
                    hits: new Array(),
                    uniqueId: uniqueId
                };
                this.uniqueIdToElement[uniqueId] = x;
                file.methods.push(x);
            }
            return this.uniqueIdToElement[uniqueId];
        };
        IstanbulToFootprintsConvertorV3.prototype.getOrCreateBranchElement = function (uniqueId, file) {
            if (!this.uniqueIdToElement[uniqueId]) {
                var x = {
                    hits: new Array(),
                    uniqueId: uniqueId
                };
                this.uniqueIdToElement[uniqueId] = x;
                if (file.branches)
                    file.branches.push(x);
            }
            return this.uniqueIdToElement[uniqueId];
        };
        IstanbulToFootprintsConvertorV3.prototype.getOrCreateFootprintsAppFile = function (fileName, app) {
            if (this.fileNameToAppFile[fileName]) {
                return this.fileNameToAppFile[fileName];
            }
            var file = {
                methods: new Array(),
                branches: new Array(),
                lines: new Array(),
                path: fileName
            };
            app.files.push(file);
            this.fileNameToAppFile[fileName] = file;
            return file;
        };
        IstanbulToFootprintsConvertorV3.prototype.createFootprintsFile = function () {
            var result = {
                configurationData: {},
                customerId: this.cfg.customerId,
                environment: {},
                tests: [],
                apps: [],
                meta: {
                    "window.sourceMap": (this.window)["sourceMap"] != null,
                    moduleToSourceMap: new Array()
                }
            };
            this.fileNameToAppFile = {};
            this.testNameToTestData = {};
            var app = {
                appName: this.cfg.appName,
                branchName: this.cfg.branchName,
                buildName: this.cfg.buildName,
                moduleName: null,
                files: new Array()
            };
            result.apps.push(app);
            return result;
        };
        IstanbulToFootprintsConvertorV3.prototype.readSourceMapData = function (sourceMapConsumer, start, fullPath) {
            if (!sourceMapConsumer)
                return null;
            try {
                var originalPosition = sourceMapConsumer.originalPositionFor(start);
                if (originalPosition && originalPosition.source && originalPosition.line !== null && originalPosition.column !== null) {
                    var originalFilename = originalPosition.source;
                    if (originalFilename.indexOf("webpack:///webpack/") === -1 &&
                        originalFilename.indexOf("webpack:///external") === -1) {
                        if (originalFilename.indexOf('webpack:///') === 0) {
                            originalFilename = originalFilename.substring(11);
                        }
                        var originalFullFilename = utils_1.Utils.resolveOriginalFullFileName(fullPath, originalFilename);
                        originalFilename = utils_1.Utils.getRelativeModulePath(originalFilename, this.cfg.workspacepath);
                        var originalStart = { line: originalPosition.line, column: originalPosition.column };
                        var result = { originalFilename: originalFilename, originalStart: originalStart, originalFullFilename: originalFullFilename };
                        return result;
                    }
                }
            }
            catch (e) {
                console.error(e);
            }
            return null;
        };
        IstanbulToFootprintsConvertorV3.prototype.formatLoc = function (loc) {
            return loc.line + ',' + loc.column;
        };
        IstanbulToFootprintsConvertorV3.prototype.createNewUniqueId = function (uniqueId, scopeData, istanbulFootprints, module) {
            module = path.normalize(module);
            if (!istanbulFootprints[module].uniqueIdsMap) {
                this.logger.debug("file " + module + " not contains uniqueIdMaps, trying to reload");
                var shortName = this.shortNameToFileMapper.resolveShortNameForFile(module);
                this.createSLMapping(module, shortName, istanbulFootprints);
            }
            var newUniqueId = istanbulFootprints[module].uniqueIdsMap[uniqueId];
            if (!newUniqueId) {
                this.logger.error("could not generate new uniqueId for '" + uniqueId + "'");
            }
            return newUniqueId;
        };
        IstanbulToFootprintsConvertorV3.prototype.createSLMapping = function (file, shortName, istanbulFootprints) {
            var elementsArr = this.createElementsArray(file, shortName, istanbulFootprints);
            var converter = new unique_id_converter_1.UniqueIdConverter(shortName);
            converter.fileElements = elementsArr;
            converter.process();
            var convertedMap = converter.uniqueIdsMap;
            console.log(convertedMap);
            console.log(converter.fileElements);
            istanbulFootprints[file].uniqueIdsMap = convertedMap;
        };
        IstanbulToFootprintsConvertorV3.prototype.createElementsArray = function (fullPath, shortName, istanbulFootprints) {
            var _this = this;
            var module = istanbulFootprints[fullPath];
            var methods = module.fnMap;
            var branches = module.branchMap;
            var branchesArr = this.createBranchElements(branches, shortName);
            var methodsArr = Object.keys(methods).map(function (key) { return _this.formatMethod(methods[key], shortName); });
            var elementsArr = methodsArr.concat(branchesArr);
            this.logger.debug("got '" + elementsArr.length + "' elements  from '" + fullPath + "'");
            return elementsArr;
        };
        IstanbulToFootprintsConvertorV3.prototype.formatMethod = function (method, file) {
            var start = method.loc.start;
            var end = method.loc.end;
            var startPosition = {
                column: start.column,
                line: start.line,
            };
            var endPosition = {
                column: end.column,
                line: end.line,
            };
            var uniqueIdKey = file + "@" + this.formatLoc(start);
            var element = new file_element_1.FileElement(contracts_1.ElementType.METHOD, startPosition, endPosition, uniqueIdKey, file);
            if (method.decl && method.decl.start) {
                element.uniqueIdKey_decl = file + "@" + this.formatLoc(method.decl.start);
            }
            return element;
        };
        IstanbulToFootprintsConvertorV3.prototype.createBranchElements = function (branchesMap, file) {
            var branchesMapArr = Object.keys(branchesMap).map(function (key) { return branchesMap[key]; });
            var branchesArr = [];
            for (var _i = 0, branchesMapArr_1 = branchesMapArr; _i < branchesMapArr_1.length; _i++) {
                var branch = branchesMapArr_1[_i];
                branchesArr = branchesArr.concat(this.extractBranchParts(branch, file));
            }
            return branchesArr;
        };
        IstanbulToFootprintsConvertorV3.prototype.extractBranchParts = function (branch, file) {
            var formattedBranches = [];
            var locations = branch.locations;
            for (var i = 0; i < locations.length; i++) {
                var startPosition = {
                    column: locations[i].start.column,
                    line: locations[i].start.line,
                };
                var endPosition = {
                    column: locations[i].end.column,
                    line: locations[i].end.line,
                };
                var uniqueIdKey = file + "|" + this.formatLoc(locations[i].start) + "|" + i;
                var element = new file_element_1.FileElement(contracts_1.ElementType.BRANCH, startPosition, endPosition, uniqueIdKey, file);
                formattedBranches.push(element);
            }
            return formattedBranches;
        };
        IstanbulToFootprintsConvertorV3.prototype.loadOriginalModules = function (istanbulFootprints) {
            var originalModulesLoader = new original_module_loader_1.OriginalModuleLoader(istanbulFootprints, this.window, this.cfg.workspacepath);
            originalModulesLoader.load();
        };
        IstanbulToFootprintsConvertorV3.prototype.mapShortNamesToFiles = function (istanbulFootprints) {
            var _this = this;
            this.shortNameToFileMapper = new short_name_to_file_mapper_1.ShortNameToFileMapper();
            Object.keys(istanbulFootprints).forEach(function (module) { return _this.shortNameToFileMapper.addFile(module); });
        };
        return IstanbulToFootprintsConvertorV3;
    }());
    exports.IstanbulToFootprintsConvertorV3 = IstanbulToFootprintsConvertorV3;
});

},{"./coverage-elements/contracts":11,"./coverage-elements/file-element":12,"./coverage-elements/original-module-loader":13,"./coverage-elements/unique-id-converter":14,"./logger/log-factory":25,"./short-name-to-file-mapper":33,"./utils":36,"path":1}],23:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils_1 = require("./utils");
    var IstanbulToFootprintsConverter = (function () {
        function IstanbulToFootprintsConverter(window, configuration) {
            this.window = window;
            this.configuration = configuration;
            if (configuration == null)
                throw new Error("'configuration' cannot be null or undefined");
        }
        IstanbulToFootprintsConverter.prototype.convert = function (istanbulFootprints) {
            var apps = {};
            var appsArray = new Array();
            if (istanbulFootprints) {
                var context = this;
                Object.keys(istanbulFootprints).forEach(function (moduleName) {
                    var m = istanbulFootprints[moduleName];
                    context.configuration.appName = context.configuration.appName || "";
                    var a = apps[context.configuration.appName];
                    var isNewApp = false;
                    if (!a) {
                        a = {
                            appName: context.configuration.appName,
                            build: context.configuration.buildName,
                            branch: context.configuration.branchName,
                            footprints: []
                        };
                        isNewApp = true;
                    }
                    var footprints = a.footprints;
                    var filename = m.path;
                    filename = filename.replace(/\\/g, '/');
                    Object.keys(m.f).forEach(function (funcId) {
                        var funcInfo = m.fnMap[funcId];
                        if (!funcInfo || funcInfo.skip)
                            return;
                        if (m.f[funcId] > 0) {
                            var mn = context.getMethodName(funcInfo.name, funcInfo.guessedName);
                            var pos = context.formatLoc(funcInfo.loc.originalStart || funcInfo.loc.start);
                            if (m.inputSourceMap && context.window["sourceMap"]) {
                                var sourceMapConsumer = new context.window["sourceMap"].SourceMapConsumer(m.inputSourceMap);
                                pos = context.formatLoc(sourceMapConsumer.originalPositionFor(funcInfo.loc.start));
                            }
                            filename = funcInfo.originalFilename || filename;
                            filename = context.getRelativeModulePath(filename);
                            var fqmn = [mn, filename, pos].join('@');
                            var hash = funcInfo.hash && funcInfo.hash.hash;
                            var footprintsItem = {
                                name: fqmn,
                                hits: m.f[funcId],
                                hash: hash,
                                branches: new Array()
                            };
                            if (m.fnToBranch && m.fnToBranch[funcId] && m.fnToBranch[funcId].length) {
                                m.fnToBranch[funcId].forEach(function (branchArray, index) {
                                    var fileBranch = branchArray[0];
                                    var branchIndex = branchArray[1];
                                    if (m.b[fileBranch.toString()][branchIndex] > 0) {
                                        footprintsItem.branches.push(index);
                                    }
                                });
                            }
                            footprints.push(footprintsItem);
                        }
                    });
                    if (footprints.length && isNewApp) {
                        appsArray.push(a);
                        apps[a.appName] = a;
                    }
                });
            }
            return appsArray;
        };
        IstanbulToFootprintsConverter.prototype.getMethodName = function (name, guessedName) {
            var mn = name || guessedName || "(Anonymous)";
            if (mn.indexOf("(anonymous") >= 0) {
                mn = "(Anonymous)";
            }
            return mn;
        };
        IstanbulToFootprintsConverter.prototype.formatLoc = function (loc) {
            return [loc.line, loc.column].join(',');
        };
        IstanbulToFootprintsConverter.prototype.getRelativeModulePath = function (path) {
            var workspacepath = utils_1.Utils.adjustPathSlashes(this.configuration.workspacepath);
            path = utils_1.Utils.adjustPathSlashes(path);
            if (workspacepath) {
                return path.replace(workspacepath, "");
            }
            return path;
        };
        return IstanbulToFootprintsConverter;
    }());
    exports.IstanbulToFootprintsConverter = IstanbulToFootprintsConverter;
});

},{"./utils":36}],24:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ConsoleLogger = (function () {
        function ConsoleLogger(level, selectedLogLevels) {
            if (level === void 0) { level = "info"; }
            if (selectedLogLevels === void 0) { selectedLogLevels = null; }
            this.level = level;
            this.selectedLogLevels = selectedLogLevels;
            this.logFn = function () { };
            this.stringifyFn = function (o) { return ""; };
            this.context = {};
            if (!selectedLogLevels)
                this.initLogLevels(level);
            this.initStringifyFn();
            this.initLogFn();
        }
        ConsoleLogger.prototype.withLogLevel = function (level) {
            var c = new ConsoleLogger(this.level);
            c.context = this.context;
            return c;
        };
        ConsoleLogger.prototype.initLogFn = function () {
            var _this = this;
            if (console && typeof (console.log) == 'function') {
                this.logFn = function (o) {
                    var line = _this.stringifyFn(o);
                    console.log(line);
                };
            }
            else {
            }
        };
        ConsoleLogger.prototype.initStringifyFn = function () {
            var jsonStringify = false;
            if (JSON && typeof (JSON.stringify) == 'function') {
                this.stringifyFn = JSON.stringify;
            }
            else {
                this.stringifyFn = this.crudeStringifier;
            }
        };
        ConsoleLogger.prototype.crudeStringifier = function (o) {
            var strParts = Array();
            for (var p in o) {
                strParts.push(p + '=' + o[p].toString());
            }
            return strParts.join(', ');
        };
        ConsoleLogger.prototype.initLogLevels = function (level) {
            this.selectedLogLevels = {};
            var logLevel = level.toLowerCase();
            var orderedLogLevels = ["trace", "debug", "info", "warning", "error", "critical", "fatal"];
            var minIdx = orderedLogLevels.indexOf(logLevel);
            for (var i = 0; i < orderedLogLevels.length; i++) {
                this.selectedLogLevels[orderedLogLevels[i]] = (i >= minIdx);
            }
        };
        ConsoleLogger.prototype.internalLog = function (logLevel, logMsg, obj) {
            if (!this.selectedLogLevels || !this.selectedLogLevels[logLevel])
                return;
            var logObject = {
                level: logLevel.toUpperCase(),
                ts: new Date().toISOString(),
                msg: logMsg ? logMsg.toString() : undefined
            };
            var ctx = this.context;
            for (var p in ctx) {
                logObject[p] = ctx[p];
            }
            if (obj) {
                if (obj instanceof Error) {
                    logObject.error = obj.toString();
                }
                else if (obj instanceof Object) {
                    for (var p in obj) {
                        logObject[p] = obj[p];
                    }
                }
                else {
                    logObject.data = obj;
                }
            }
            ;
            this.logFn(logObject);
        };
        ConsoleLogger.prototype.clone = function () {
            var c = new ConsoleLogger(this.level, this.selectedLogLevels);
            var _t = this.context;
            for (var p in _t) {
                c.context[p] = _t[p];
            }
            ;
            return c;
        };
        ConsoleLogger.prototype.withClass = function (className) {
            var c = this.clone();
            c.context.className = className;
            delete c.context.methodName;
            return c;
        };
        ConsoleLogger.prototype.withMethod = function (methodName) {
            var c = this.clone();
            c.context.methodName = methodName;
            return c;
        };
        ConsoleLogger.prototype.withTx = function (tx) {
            var c = this.clone();
            c.context.tx = tx;
            return c;
        };
        ConsoleLogger.prototype.withComponent = function (componentName, componentVersion) {
            var c = this.clone();
            c.context.componentName = componentName;
            c.context.componentVersion = componentVersion;
            return c;
        };
        ConsoleLogger.prototype.withActivity = function (activityName) {
            var c = this.clone();
            c.context.activityName = activityName;
            return c;
        };
        ConsoleLogger.prototype.withProperty = function (propName, propValue) {
            var c = this.clone();
            c.context[propName] = propValue;
            return c;
        };
        ConsoleLogger.prototype.withProperties = function (objWithProperties, propNames) {
            var c = this.clone();
            if (!propNames) {
                propNames = Object.keys(objWithProperties);
            }
            propNames.forEach(function (pn) {
                c.context[pn] = objWithProperties[pn];
            });
            return c;
        };
        ConsoleLogger.prototype.fatal = function (logMsg, obj) {
            this.internalLog('fatal', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.critical = function (logMsg, obj) {
            this.internalLog('critical', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.error = function (logMsg, obj) {
            this.internalLog('error', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.warn = function (logMsg, obj) {
            this.internalLog('warning', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.info = function (logMsg, obj) {
            this.internalLog('info', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.debug = function (logMsg, obj) {
            this.internalLog('debug', logMsg, obj);
        };
        ;
        ConsoleLogger.prototype.trace = function (logMsg, obj) {
            this.internalLog('trace', logMsg, obj);
        };
        ;
        return ConsoleLogger;
    }());
    exports.ConsoleLogger = ConsoleLogger;
});

},{}],25:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./null-logger", "./console-logger"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var null_logger_1 = require("./null-logger");
    var console_logger_1 = require("./console-logger");
    var LogFactory = (function () {
        function LogFactory() {
        }
        LogFactory.createLogger = function (className, logLevel) {
            try {
                if (logLevel == "off")
                    return null_logger_1.NullLogger.INSTANCE;
                var logger = new console_logger_1.ConsoleLogger();
                logger.withClass(className);
                return logger;
            }
            catch (e) {
                return null_logger_1.NullLogger.INSTANCE;
            }
        };
        return LogFactory;
    }());
    exports.LogFactory = LogFactory;
});

},{"./console-logger":24,"./null-logger":26}],26:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var NullLogger = (function () {
        function NullLogger() {
        }
        NullLogger.prototype.fatal = function (logMsg, obj) {
        };
        NullLogger.prototype.critical = function (logMsg, obj) {
        };
        NullLogger.prototype.error = function (logMsg, obj) {
        };
        NullLogger.prototype.warn = function (logMsg, obj) {
        };
        NullLogger.prototype.info = function (logMsg, obj) {
        };
        NullLogger.prototype.debug = function (logMsg, obj) {
        };
        NullLogger.prototype.trace = function (logMsg, obj) {
        };
        NullLogger.prototype.withClass = function (className) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withMethod = function (methodName) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withTx = function (tx) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withComponent = function (componentName, componentVersion) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withActivity = function (activityName) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withProperty = function (propName, propValue) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withProperties = function (objWithProperties, propNames) {
            return NullLogger.INSTANCE;
        };
        NullLogger.prototype.withLogLevel = function (level) {
            return NullLogger.INSTANCE;
        };
        NullLogger.INSTANCE = new NullLogger();
        return NullLogger;
    }());
    exports.NullLogger = NullLogger;
});

},{}],27:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../entities/footprints-item-data", "../delegate"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var footprints_item_data_1 = require("../entities/footprints-item-data");
    var delegate_1 = require("../delegate");
    var FootprintsItemsQueue = (function () {
        function FootprintsItemsQueue(configuration) {
            this.maxItemsInQueue = 500;
            this.queueSize = 0;
            this.queue = new Array();
            this.onQueueFull = new delegate_1.Delegate();
            this.isQueueFull = function () {
                return (this.getCurrentQueueSize() >= this.maxItemsInQueue);
            };
            if (!configuration)
                throw new Error("'configuration' cannot be null or undefined");
            this.enabled = configuration.enabled;
            this.maxItemsInQueue = configuration.maxItemsInQueue;
        }
        FootprintsItemsQueue.prototype.setEnabled = function (isEnabled) {
            isEnabled = !!isEnabled;
            if (isEnabled !== this.enabled) {
                this.enabled = isEnabled;
            }
            if (!isEnabled) {
                this.queue = new Array();
            }
        };
        ;
        FootprintsItemsQueue.prototype.getEnabled = function () {
            return this.enabled;
        };
        ;
        FootprintsItemsQueue.prototype.enqueueItem = function (footprintsItem) {
            if (!this.enabled) {
                return;
            }
            footprintsItem = footprintsItem || new footprints_item_data_1.FootprintsItemData();
            footprintsItem.localTime = new Date().valueOf();
            this.queue.push(footprintsItem);
            this.queueSize++;
            this.checkQueueSize();
        };
        ;
        FootprintsItemsQueue.prototype.checkQueueSize = function () {
            if (this.isQueueFull()) {
                this.onQueueFull.fire();
            }
        };
        ;
        FootprintsItemsQueue.prototype.getCurrentQueueSize = function () {
            return this.queueSize;
        };
        ;
        FootprintsItemsQueue.prototype.requeueItems = function (footprintsItems) {
            if (!this.enabled) {
                return;
            }
            var context = this;
            footprintsItems.forEach(function (item) {
                context.queue.push(item);
                context.queueSize += 1;
            });
            this.checkQueueSize();
        };
        ;
        FootprintsItemsQueue.prototype.getQueueContentsAndEmptyQueue = function () {
            var returnedItems = this.queue;
            this.queue = new Array();
            this.queueSize = 0;
            return returnedItems;
        };
        ;
        return FootprintsItemsQueue;
    }());
    exports.FootprintsItemsQueue = FootprintsItemsQueue;
});

},{"../delegate":15,"../entities/footprints-item-data":19}],28:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FootprintsServiceProxy = (function () {
        function FootprintsServiceProxy(configuration, jsonClient, logger) {
            this.configuration = configuration;
            this.jsonClient = jsonClient;
            this.logger = logger;
        }
        FootprintsServiceProxy.prototype.submitRequest = function (request, onSuccess, onError, async) {
            if (async === void 0) { async = true; }
            var url = this.createServerUrl(this.configuration);
            this.jsonClient.post(url, request, onSuccess, onError, async);
        };
        FootprintsServiceProxy.prototype.hasRequestsInProgress = function () {
            return this.jsonClient.hasRequestsInProgress();
        };
        FootprintsServiceProxy.prototype.getRequestsInProgressCount = function () {
            return this.jsonClient.requestsInProgress;
        };
        FootprintsServiceProxy.prototype.createServerUrl = function (configuration) {
            if (configuration.token) {
                var apiVersion = configuration.resolveWithoutHash ? "/v5" : "/v3";
                return configuration.server + apiVersion + "/agents/footprints/";
            }
            return configuration.server + "/v1/testfootprints/";
        };
        return FootprintsServiceProxy;
    }());
    exports.FootprintsServiceProxy = FootprintsServiceProxy;
});

},{}],29:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./http-response"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var http_response_1 = require("./http-response");
    var HttpClient = (function () {
        function HttpClient(window, featureDetection, logger) {
            this.window = window;
            this.featureDetection = featureDetection;
            this.logger = logger;
            if (window == null)
                throw new Error("'window' cannot be null or undefined");
            if (featureDetection == null)
                throw new Error("'featureDetection' cannot be null or undefined");
        }
        HttpClient.prototype.send = function (request, onSuccess, onError) {
            if (!request.url)
                return;
            var url = request.url;
            var dataAsString = request.data;
            var httpMethod = request.httpMethod;
            var httpRequest = new XMLHttpRequest();
            httpRequest.open(httpMethod, url, request.async);
            if (request.headers) {
                for (var i = 0; i < request.headers.length; i++) {
                    var header = request.headers[i];
                    if (header && header.name && header.value) {
                        httpRequest.setRequestHeader(header.name, header.value);
                    }
                }
            }
            httpRequest.onreadystatechange = function () {
                if (httpRequest.readyState === XMLHttpRequest.DONE) {
                    var httpResponse = new http_response_1.HttpResponse();
                    httpResponse.statusCode = httpRequest.status;
                    httpResponse.responseText = httpRequest.responseText;
                    if (httpRequest.status === 200) {
                        if (onSuccess) {
                            onSuccess(httpResponse);
                        }
                    }
                    else {
                        if (onError) {
                            onError(httpResponse);
                        }
                    }
                }
            };
            httpRequest.send(dataAsString);
        };
        return HttpClient;
    }());
    exports.HttpClient = HttpClient;
});

},{"./http-response":31}],30:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var HttpRequest = (function () {
        function HttpRequest() {
            this.async = true;
        }
        return HttpRequest;
    }());
    exports.HttpRequest = HttpRequest;
});

},{}],31:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var HttpResponse = (function () {
        function HttpResponse() {
        }
        return HttpResponse;
    }());
    exports.HttpResponse = HttpResponse;
});

},{}],32:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../http/http-request"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var http_request_1 = require("../http/http-request");
    var JsonClient = (function () {
        function JsonClient(httpClient, token) {
            this.httpClient = httpClient;
            this.token = token;
            this.requestsInProgress = 0;
            this.requestsInProgress = 0;
        }
        JsonClient.prototype.sendHttpRequest = function (request, onSuccess, onError) {
            var context = this;
            try {
                this.requestsInProgress++;
                var httpRequest = new http_request_1.HttpRequest();
                httpRequest.headers = this.getHeaders();
                httpRequest.url = request.url;
                httpRequest.httpMethod = request.httpMethod;
                httpRequest.async = request.async;
                if (request.data != null)
                    httpRequest.data = JSON.stringify(request.data);
                this.httpClient.send(httpRequest, parseResponse, function (response) {
                    context.requestsInProgress--;
                    if (onError != null) {
                        onError(response);
                    }
                });
            }
            catch (e) {
                this.requestsInProgress--;
            }
            function parseResponse(jsonResponse) {
                try {
                    context.requestsInProgress--;
                    if (jsonResponse && jsonResponse.responseText && jsonResponse.responseText != "") {
                        var object = JSON.parse(jsonResponse.responseText);
                    }
                    if (onSuccess != null) {
                        onSuccess(object);
                    }
                }
                catch (e) {
                    if (onError != null) {
                        jsonResponse.responseText = "Failed parsing response. Response: '" + jsonResponse.responseText + "'";
                        onError(jsonResponse);
                    }
                }
            }
        };
        JsonClient.prototype.post = function (url, data, onSuccess, onError, async) {
            if (async === void 0) { async = true; }
            this.send(url, data, onSuccess, onError, async, "POST");
        };
        JsonClient.prototype.get = function (url, onSuccess, onError, async, data) {
            if (async === void 0) { async = true; }
            this.send(url, data, onSuccess, onError, async, "GET");
        };
        JsonClient.prototype.send = function (url, data, onSuccess, onError, async, httpMethod) {
            if (async === void 0) { async = true; }
            var request = new http_request_1.HttpRequest();
            request.url = url;
            request.data = data;
            request.httpMethod = httpMethod;
            request.async = async;
            this.sendHttpRequest(request, onSuccess, onError);
        };
        JsonClient.prototype.hasRequestsInProgress = function () {
            return this.requestsInProgress > 0;
        };
        JsonClient.prototype.getHeaders = function () {
            var headers = [{ name: "Content-Type", value: "application/json" }];
            if (this.token) {
                headers.push({ name: 'Authorization', value: 'Bearer ' + this.token });
            }
            return headers;
        };
        return JsonClient;
    }());
    exports.JsonClient = JsonClient;
});

},{"../http/http-request":30}],33:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "./logger/log-factory", "./utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path = require("path");
    var log_factory_1 = require("./logger/log-factory");
    var utils_1 = require("./utils");
    var ShortNameToFileMapper = (function () {
        function ShortNameToFileMapper() {
            this.shortNameToFile = {};
            this.fileAlreadyAddedMap = {};
            this.isDuplicateResolves = false;
            this.logger = log_factory_1.LogFactory.createLogger("ShortNameToFileMapper", "");
        }
        ShortNameToFileMapper.prototype.addFile = function (file) {
            file = utils_1.Utils.adjustPathSlashes(file);
            if (this.fileAlreadyAddedMap[file]) {
                return;
            }
            var base = path.basename(file);
            this.addShortNameToFile(base, file);
            this.fileAlreadyAddedMap[file] = true;
        };
        ShortNameToFileMapper.prototype.resolveShortNameForFile = function (file) {
            file = utils_1.Utils.adjustPathSlashes(file);
            if (!this.isDuplicateResolves) {
                this.findShortPathForDuplicates();
                this.isDuplicateResolves = true;
            }
            var pathParts = file.split("/");
            var counter = pathParts.length - 1;
            var shortestPath = null;
            while (counter >= 0 && shortestPath == null) {
                var currentShort = pathParts.slice(counter).join("/");
                if (!this.shortNameToFile[currentShort]) {
                    this.logger.warn("could not find short name for '" + file + "'");
                    shortestPath = currentShort;
                }
                else if (Array.isArray(this.shortNameToFile[currentShort]) &&
                    !(this.shortNameToFile[currentShort].length > 1)) {
                    this.logger.debug("found '" + currentShort + "' as  short name for '" + file + "'");
                    shortestPath = currentShort;
                }
                counter--;
            }
            if (!shortestPath) {
                this.logger.warn("could not find short name for '" + file + "'");
                return file;
            }
            return shortestPath;
        };
        ShortNameToFileMapper.prototype.findShortPathForDuplicates = function () {
            var shortNames = Object.keys(this.shortNameToFile);
            for (var _i = 0, shortNames_1 = shortNames; _i < shortNames_1.length; _i++) {
                var shortName = shortNames_1[_i];
                if (this.shortNameToFile[shortName].length > 1) {
                    this.mapDuplicates(this.shortNameToFile[shortName]);
                }
            }
        };
        ShortNameToFileMapper.prototype.mapDuplicates = function (duplicates) {
            for (var _i = 0, duplicates_1 = duplicates; _i < duplicates_1.length; _i++) {
                var file = duplicates_1[_i];
                var parts = file.split("/");
                var counter = parts.length - 2;
                while (counter >= 0) {
                    var shortName = parts.slice(counter).join("/");
                    this.addShortNameToFile(shortName, file);
                    counter--;
                }
            }
        };
        ShortNameToFileMapper.prototype.addShortNameToFile = function (shortName, file) {
            this.shortNameToFile[shortName] = this.shortNameToFile[shortName] || [];
            this.shortNameToFile[shortName].push(file);
        };
        return ShortNameToFileMapper;
    }());
    exports.ShortNameToFileMapper = ShortNameToFileMapper;
});

},{"./logger/log-factory":25,"./utils":36,"path":1}],34:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./delegate"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var delegate_1 = require("./delegate");
    var StateTracker = (function () {
        function StateTracker(configuration, jsonClient, watchdog, logger) {
            var _this = this;
            this.configuration = configuration;
            this.jsonClient = jsonClient;
            this.watchdog = watchdog;
            this.logger = logger;
            this.colorChanged = new delegate_1.Delegate();
            this.setCurrentTestIdentifier(StateTracker.ANONYMOUS_FOOTPRINTS_COLOR);
            this.watchdog.addOnAlarmListener(function () {
                _this.checkForActiveExecution();
            });
            this.watchdog.start();
        }
        StateTracker.prototype.setCurrentTestIdentifier = function (newColorOnWindow) {
            if (newColorOnWindow != null) {
                if (newColorOnWindow != StateTracker.ANONYMOUS_FOOTPRINTS_COLOR) {
                    this.stopWatchdog();
                }
                else {
                    this.startWatchdog();
                }
                if (newColorOnWindow != this.currentColorOnWindow) {
                    this.currentColorOnWindow = newColorOnWindow;
                    this.colorChanged.fire();
                }
            }
            else if (this.currentColorOnWindow != null && newColorOnWindow == null) {
                this.currentColorOnWindow = null;
                this.colorChanged.fire();
            }
        };
        StateTracker.prototype.getCurrentTestIdentifier = function () {
            return this.currentColorOnWindow;
        };
        StateTracker.prototype.addOnColorChangedListener = function (listener) {
            this.colorChanged.addListener(listener);
        };
        StateTracker.prototype.getCurrentColor = function () {
            return this.currentColorOnWindow;
        };
        StateTracker.prototype.checkForActiveExecution = function () {
            var url = this.configuration.server + '/v3/testExecution';
            var queryParams = {
                customerId: this.configuration.customerId,
                environment: this.configuration.labId
            };
            url += "?customerId=" + queryParams.customerId + "&environment=" + queryParams.environment;
            this.logger.info("[TO TST] - checkMappingStatus. Url '" + url + "'.");
            var context = this;
            var onSuccess = function (data) {
                context.logger.info("[ACTIVE EXECUTION] Checking for active execution. No errors");
                if (data == null) {
                    context.logger.info("[ACTIVE EXECUTION] Couldn't find active execution. not sending footprints.");
                    context.hasActiveExecution = false;
                }
                else if (data.status == "pendingDelete") {
                    context.logger.info("[ACTIVE EXECUTION] Execution is pending delete. sending last footprints");
                    context.hasActiveExecution = true;
                }
                else if (data.status == null || data.status != "created") {
                    context.logger.warn("[ACTIVE EXECUTION] Unexpected status. status: ", data.status);
                    context.hasActiveExecution = true;
                }
                else {
                    context.logger.info("[ACTIVE EXECUTION] Active execution for: " + JSON.stringify(queryParams) + ". data: " + JSON.stringify(data));
                    context.hasActiveExecution = true;
                }
            };
            var onError = function (response) {
                if (response.statusCode == 404) {
                    context.logger.info("[ACTIVE EXECUTION] Couldn't find active execution. not sending footprints.");
                }
                else {
                    context.logger.error("[ACTIVE EXECUTION] Error checking for active execution: ", response.responseText);
                }
                context.hasActiveExecution = false;
            };
            this.jsonClient.get(url, onSuccess, onError);
        };
        ;
        StateTracker.prototype.shouldCollectFootprints = function () {
            if (this.getCurrentColor() == null) {
                this.logger.info("Current test identifier is null, should not collect footprints");
                return false;
            }
            if (this.getCurrentColor() != StateTracker.ANONYMOUS_FOOTPRINTS_COLOR) {
                this.logger.info("Not in anonymous footprints, should collect footprints");
                return true;
            }
            if (this.hasActiveExecution) {
                this.logger.info("Has active execution, should collect footprints");
                return true;
            }
            this.logger.info("No active execution, should not collect footprints");
            return false;
        };
        StateTracker.prototype.stopWatchdog = function () {
            if (this.watchdog.getStatus().running) {
                this.watchdog.stop();
            }
        };
        StateTracker.prototype.startWatchdog = function () {
            if (!this.watchdog.getStatus().running) {
                this.watchdog.start();
            }
        };
        StateTracker.ANONYMOUS_FOOTPRINTS_COLOR = "00000000-0000-0000-0000-000000000000/__init";
        return StateTracker;
    }());
    exports.StateTracker = StateTracker;
});

},{"./delegate":15}],35:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var TestStateHelper = (function () {
        function TestStateHelper() {
            this.combineExecutionIdAndTestName = function (executionId, testName) {
                testName = testName || '';
                if (!executionId)
                    return '';
                return executionId + '/' + testName;
            };
            this.splitTestIdToExecutionAndTestName = function (testId) {
                testId = testId || '';
                var executionId = testId.split('/')[0];
                var testName = (testId.indexOf('/') == -1) ? "" : testId.substring(executionId.length + 1);
                if (!executionId)
                    testName = "";
                return { executionId: executionId, testName: testName };
            };
        }
        return TestStateHelper;
    }());
    exports.TestStateHelper = TestStateHelper;
});

},{}],36:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path = require("path");
    var Utils = (function () {
        function Utils() {
        }
        Utils.adjustPathSlashes = function (path) {
            path = (path || "").replace(/\\/g, '/');
            return path;
        };
        Utils.getRelativeModulePath = function (path, workspacepath) {
            workspacepath = Utils.adjustPathSlashes(workspacepath);
            path = Utils.adjustPathSlashes(path);
            if (workspacepath) {
                return path.replace(workspacepath, "");
            }
            return path;
        };
        Utils.resolveOriginalFullFileName = function (fullPath, originalFilename) {
            if (path.isAbsolute(originalFilename)) {
                return originalFilename;
            }
            var generatedDir = path.dirname(fullPath);
            originalFilename = path.resolve(generatedDir, originalFilename);
            return originalFilename;
        };
        return Utils;
    }());
    exports.Utils = Utils;
});

},{"path":1}],37:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ValidationUtils = (function () {
        function ValidationUtils() {
        }
        ValidationUtils.verifyNotNullOrEmpty = function (value, paramName) {
            if (value === undefined || value === null) {
                throw new Error(paramName + " " + ValidationUtils.CANNOT_BE_NULL_OR_UNDEFINED + ".");
            }
            if (typeof (value) === "string" && value.length === 0) {
                throw new Error(paramName + " " + ValidationUtils.CANNOT_BE_EMPTY_STRING + ".");
            }
        };
        ValidationUtils.CANNOT_BE_NULL_OR_UNDEFINED = "cannot be null or undefined.";
        ValidationUtils.CANNOT_BE_EMPTY_STRING = "cannot be empty string";
        return ValidationUtils;
    }());
    exports.ValidationUtils = ValidationUtils;
});

},{}],38:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./delegate"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var delegate_1 = require("./delegate");
    var Watchdog = (function () {
        function Watchdog(timeout, timersWrapper, options, logger) {
            this.timeout = timeout;
            this.timersWrapper = timersWrapper;
            this.options = options;
            this.logger = logger;
            this.handle = null;
            this.alarm = new delegate_1.Delegate();
            this.context = this;
            this.stopped = false;
            this.options = options || {};
        }
        Watchdog.prototype.abortTimer = function () {
            if (this.handle) {
                this.timersWrapper.clearTimeout(this.handle);
                this.handle = null;
            }
        };
        Watchdog.prototype.fireAlarm = function () {
            this.handle = null;
            try {
                this.alarm.fire();
            }
            catch (e) {
                this.logger.error('Alarm caught an exception: ', e);
            }
            if (this.options.autoReset) {
                this.context.reset();
            }
        };
        Watchdog.prototype.addOnAlarmListener = function (listener) {
            this.alarm.addListener(listener);
        };
        Watchdog.prototype.reset = function () {
            var _this = this;
            this.abortTimer();
            if (!this.stopped) {
                this.handle = this.timersWrapper.setTimeout(function () {
                    _this.fireAlarm();
                }, this.timeout);
            }
        };
        Watchdog.prototype.stop = function () {
            this.stopped = true;
            this.abortTimer();
        };
        Watchdog.prototype.start = function () {
            this.stopped = false;
            this.reset();
        };
        Watchdog.prototype.getStatus = function () {
            return {
                running: !this.stopped
            };
        };
        return Watchdog;
    }());
    exports.Watchdog = Watchdog;
});

},{"./delegate":15}],39:[function(require,module,exports){
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var WindowTimersWrapper = (function () {
        function WindowTimersWrapper(window) {
            this.window = window;
            if (!this.window)
                throw new Error("'window' cannot be null or undefined");
        }
        WindowTimersWrapper.prototype.clearInterval = function (handle) {
            this.window.clearInterval(handle);
        };
        WindowTimersWrapper.prototype.clearTimeout = function (handle) {
            this.window.clearTimeout(handle);
        };
        WindowTimersWrapper.prototype.setInterval = function (handler, timeout) {
            var args = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                args[_i - 2] = arguments[_i];
            }
            return this.window.setInterval(handler, timeout, args);
        };
        WindowTimersWrapper.prototype.setTimeout = function (handler, timeout) {
            var args = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                args[_i - 2] = arguments[_i];
            }
            return this.window.setTimeout(handler, timeout, args);
        };
        return WindowTimersWrapper;
    }());
    exports.WindowTimersWrapper = WindowTimersWrapper;
});

},{}]},{},[3]);
